<?php
namespace Migo\Clients;
use log as log, Migo;
use Exception;
/**
 * Migo THERMOSTAT API PHP CLIENT
 *
* @author Originally written by Enzo Macriadapted by Limad35
 */
//require_once dirname(__FILE__) . '/../../../../../core/php/corefile.php';	
const DTYPE=["NAVaillant"];

class VTThermApiClient extends VTApiClient {
	public static $app_version="1.4.0.1";
	private static $device_type="NAVaillant";
	public function _getHomesdata($home_id = NULL, $gateway_types= "NAVaillant"){
        $params = [
          			"gateway_types"=>['NAVaillant'],
       				"detailed_config"=>true,
       				"gateway_parameters"=> ["NAVaillant"=>["sync_measures"=>true]]
        ];
      	if(!is_null($home_id)) $params['home_id'] = $home_id ;
		if(!is_null($gateway_types)) $params['gateway_types'][] = $gateway_types ;
      	return $this->api('gethomesdata', 'GET', $params);
    }
  
  
  
	public function getVtData($device_id = null){
     	$params =['device_type'=>'NAVaillant'];//,'lower_access_level'=>"0"
      	$params['sync_device_id'] = "all";
		if(!is_null($device_id)) $params['device_id'] = $device_id ;
      	else $params['sync_device_id'] = "all";
		try {
			if(!is_null($device_id)) $this->syncthermstate($device_id);
        }
		catch (Exception $ex) {
			//$error_msg = __CLASS__.'::'.__FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
          	$error_msg = __CLASS__.'::'.__FUNCTION__." " . $ex->getMessage();
          	log::add('migoThermostat', 'warning', '  '. __FUNCTION__ .$error_msg);
        }
      	$return = $this->api('getthermostatsdata', 'POST', $params);
      	return $return;
	}
	public function syncthermstate($device_id){
		$params =array('device_id'=>$device_id);
		$return = $this->api('syncthermstate ', 'POST', $params);
      	return $return;
	}
	public function getoutdoortemperature($device_id){
		$params = array('device_id'=>$device_id);//,'lower_access_level'=>"0"
		$return = $this->api('getoutdoortemperature', 'GET', $params);
      	return $return['temperature'];
	}
	/////////////////////////set Manual mode	
	public function _Homefacility(){//$apiHome
		try {
			$home_id = null;
          	$RqstData = $this->_Homesdata($home_id);
          	if(empty($RqstData['homes'])){
        		log::add('migoThermostat', 'warning', '  ******'.__FUNCTION__ .' No Home found at _Homesdata: '. json_encode($RqstData));
              	$error_msg = "Aucun groupe d'équipement associé à ce compte";
          		return;
              	//throw new Exception($error_msg);
        	}
          	//log::add('migoThermostat', 'info', '  ******'.__FUNCTION__ .' Data: '. json_encode($RqstData['homes']));
          	$apiHome=null;
            foreach($RqstData['homes'] as $home) {//array multi scope
				if( !isset($home['rooms']) || !isset($home['modules'])
                    || empty($home['rooms']) || empty($home['modules'])
                    || !isset($home['name']) || !isset($home['id'])){
					//log::add('migoThermostat', 'info', '  ******'.__FUNCTION__ ." Invalid home : ".$home['name'] );
                    continue;
                }
                $apiHome[$home['id']]['Data'] = $home;
                $nbrelai=count($home['modules']);
                $homeid = $home['id'];
                $homeName=$home['name'];
			}
          	if(!$apiHome){
        		$error_msg = "Aucun équipement valide trouvé";
          		throw new Exception($error_msg);
        	}
        }
		catch (Exception $ex) {
			//$error_msg = __CLASS__.'::'.__FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
          	$error_msg = __CLASS__.'::'.__FUNCTION__." " . $ex->getMessage();
          	throw new Exception($error_msg);
           
		}
      	//$apiHomeFile = __DIR__  . '/../../../data/apiHome_virt.json';
      	//$apiHome = json_decode(file_get_contents($apiHomeFile),true);
      	foreach ($apiHome as $homeid=>$home) {
          	//log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' _Homesdata '. $homeid. ' => '.json_encode($home));
			if(!isset($apiHome[$homeid]['Status']) ){
				//log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' homeid '. $homeid. ' => '.json_encode($home));
				try {
					$eqhome_Id = 'Home|'.$homeid; 
          			$global[$homeid][$eqhome_Id]['home_name']=$home['Data']['name'];
                    $apiStatus = $this->_syncHomeStatus($homeid);
                  	$RqstStatus = $apiStatus['home'];
                  	$apiHome[$homeid]['Status'] = $RqstStatus;
                    //log::add('migoThermostat', 'info', '  ******'.__FUNCTION__ .' _syncHomeStatus: '. json_encode($RqstStatus));
          	    
                  	isset($apiStatus['errors']) ? $RqstStatus['errors']= $apiStatus['errors']:"";
                    if(isset($apiStatus['errors'])){
                      	foreach ($apiStatus['errors'] as $statusErr) {
                          	//log::add('migoThermostat', 'warning', ''.__FUNCTION__ . ' Erreur signalé Homestatus: '.json_encode($statusErr));
                        }
                    }
                  	if(isset($RqstStatus['id']) AND ( !isset($RqstStatus['modules']) || !isset($RqstStatus['rooms'])) ){
                      		$errMsg = 'Home ('.$home['Data']['name']. ') est injoignable par l\'Api depuis: '
                              .date('d-m-Y H:i');
                      		$global[$homeid][$eqhome_Id]['home_status'] = false;
                      		$global[$homeid][$eqhome_Id]['errors'][7]['home_status_Nok'] = $errMsg ;
                      		//log::add('migoThermostat', 'warning', '	'.__FUNCTION__ .' err: '.$errMsg);
                      		//throw new Exception($errMsg);
                    }
                  	elseif( isset($RqstStatus['id']) ){
                        //log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' _Homestatus '.$RqstStatus['id'].'--'. json_encode($RqstStatus));
                    	//$apiHome[$homeid]['Status'] = $RqstStatus;
                        $global[$homeid]['ASyncTime']=$syncTime=date('d-m-Y H:i');
                      	$global[$homeid][$eqhome_Id]['boiler_anticipating'] = false;//par default
                      	$global[$homeid][$eqhome_Id]['boiler_status'] = false;//par default
                      	$global[$homeid][$eqhome_Id]['home_status']=true;
                    }
                }
                catch (Exception $ex) {
                  	//log::add('migoThermostat', 'warning', ''.__FUNCTION__ ." " . $ex->getMessage());
                    $error_msg = __CLASS__.'::'.__FUNCTION__." " . $ex->getMessage();
          			throw new Exception($error_msg);

                }
			}
          	
          	if(!isset($eqhome_Id) ){
				$eqhome_Id = 'Home|'.$homeid; 
          		$global[$homeid][$eqhome_Id]['home_name']=$home['Data']['name'];
          	}
          	$homeData = $apiHome[$homeid]['Data'];
          	$homeStatus = $apiHome[$homeid]['Status'];
          	
            $global[$homeid][$eqhome_Id]['spm_duaration'] = isset($homeData['therm_setpoint_default_duration']) ? $homeData['therm_setpoint_default_duration'] : null;
          
           
          	$home_modetech = isset($homeData['therm_mode']) ? $homeData['therm_mode'] : false;
          	$global[$homeid][$eqhome_Id]['home_modetech'] = $home_modetech;
          	
          
          	//$global[$homeid][$eqhome_Id]['datahome_modetech'] = $home_modetech;
          	//$global[$homeid][$eqhome_Id]["home_type"] = $homeData["home_type"];
            //$global[$homeid][$eqhome_Id]["therm_heating_energy"] = $homeData["therm_heating_energy"];
            //$global[$homeid][$eqhome_Id]["home_size"] = $homeData["home_size"];
            $global[$homeid][$eqhome_Id]['thermPriority'] = $homeData['therm_heating_priority'];   
          	$global[$homeid][$eqhome_Id]['anticipation_enabled'] = $homeData['anticipation'];
          	foreach ($homeData['modules'] as $module) {
               	if (null === $module['id']){
					continue;
                }
              	if ($module['type'] != "NAPlug" && $module['type'] != "OTH" && $module['type'] != "NAVaillant"){
					continue;
                }
              	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__.' Relay... : ' .$module['type']." =>".$module['name']." ".$module['name']);
              
              	$naplug=$module;
              	$plug_id = $naplug['id'];
              	
              	if( !isset($global[$homeid][$eqhome_Id]['temperature_outdoor']) ){
					if($naplug['type'] == "NAPlug"){
						$temperature_outdoor = "";
                        try{
							$temperature_outdoor = $this->_getoutdoortemperature($plug_id);
                          	$global[$homeid][$eqhome_Id]['temperature_outdoor'] = $temperature_outdoor;
						}catch (Exception $ex) {
							$error_msg = __FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
							//log::add('migoThermostat', 'warning', '  ******'.__FUNCTION__ .' '.$error_msg);
						}
                  		
                    }
                }  
                $keyp_search = array_search($plug_id, array_column($homeStatus['modules'], 'id'));
              	//if($keyp_search !== false){
              	$naplug_Infos=[];
                if(!is_null($keyp_search) && $keyp_search !== false){
                	$naplug_status=$homeStatus['modules'][$keyp_search];
                    $naplug_Infos = array_merge($naplug, $naplug_status );
                  	 
                  	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ ." Relay_status $keyp_search:  " .json_encode($naplug_status));
                }
                elseif($keyp_search === false || $naplug['reachable'] != true){
                  	$name = isset($naplug['name']) ?  $naplug['name'] : $naplug['id'];
                  	$Plug_last_seen = isset($naplug['last_seen']) ?  " depuis: ".date('d-m-Y H:i', $naplug['last_seen']):"";
					$errMsg = "Le relai (".$name.") est injoignable par l'Api".$Plug_last_seen;
                    $global[$homeid][$eqhome_Id]['errors'][0]["plug_reachable_Nok"] = $errMsg ;
					$naplug_Infos["plug_reachable_Nok"] = true;
                    $naplug_Infos = $naplug;
                  	//log::add('migoThermostat', 'warning', '	'.__FUNCTION__ .' '.$errMsg);
                    	
                }
              	//unset($naplug_Infos["id"]);
                if(isset($naplug_Infos["reachable"])){
					$global[$homeid][$eqhome_Id]['reachable'] = $naplug_Infos["reachable"];
                }
              	if(isset($naplug_Infos["rf_strength"])){
					$global[$homeid][$eqhome_Id]['home_rf'] = $home_rf=round($naplug_Infos['rf_strength']/1.7);
					$global[$homeid][$eqhome_Id]['home_rfstatus'] = $rf_status= $this->getrfstate($home_rf);
                  	$naplug_Infos["rfpower"] = $rf_status;
                }
              	if(isset($naplug_Infos["wifi_strength"])){
                  	$wifi_strength = round($naplug_Infos['wifi_strength']);
                  	$wifipower = $this->get_naWifi($wifi_strength);
                  	$global[$homeid][$eqhome_Id]['wifi_strength'] = $home_wifi = $wifi_strength;
                  	$naplug_Infos['wifipower'] = $wifipower;
                  	
                }
              	$global[$homeid][$eqhome_Id]['modules'][$plug_id] = $naplug_Infos;
              
              	//$global[$homeid][$eqhome_Id]['eqmodules'] = json_encode($naplug_Infos, JSON_UNESCAPED_UNICODE);
              	   
              	unset($naplug_Infos["customer_id"]);
              	unset($naplug_Infos["linked_station_mac"]);
              	unset($naplug_Infos["linked_station_ext_module"]);
              
              	unset($naplug_Infos["setup_date"]);
              	unset($naplug_Infos["outdoor_temperature"]);
              	//unset($naplug_Infos["event_history"]);
              	//unset($naplug_Infos["link_station"]);
              	unset($naplug_Infos["last_bilan"]);
              	unset($naplug_Infos["is_homekit_compatible"]);
              	unset($naplug_Infos["max_modules_nb"]);
              	$plugs[] = $naplug_Infos;
                  	
              
              	$global[$homeid][$eqhome_Id]['Plugs_Id'][] = $plug_id;
              	foreach ($naplug['modules_bridged'] as $moduleId) {
                  	$keyd_search = array_search($moduleId, array_column($homeData['modules'], 'id'));
                  	if(!is_null($keyd_search) && $keyd_search !== false){
                      $datamodule=$homeData['modules'][$keyd_search];
                      //log::add('migoThermostat', 'debug', '	'.__FUNCTION__ ."    datamodule trouvé: $keyd_search " .json_encode($datamodule));
                    }  
                  	$keym_search = isset($homeStatus['modules']) ? array_search($moduleId, array_column($homeStatus['modules'], 'id')) : null;
                  
                    if(!is_null($keym_search) && $keym_search !== false){
                        $statusmodule=$homeStatus['modules'][$keym_search];
                        //log::add('migoThermostat', 'debug', '	'.__FUNCTION__ ."    statusmodule trouvé: $keym_search " .json_encode($statusmodule));
                    }
                  
                  	if(isset($statusmodule)){
                  		$infosModule = array_merge($datamodule, $statusmodule );
						
						if(isset($infosModule["boiler_valve_comfort_boost"]) && $infosModule["boiler_valve_comfort_boost"] == true){
                        	$global[$homeid][$eqhome_Id]['boiler_valve_comfort_boost'] = true;
						}
                      	//log::add('migoThermostat', 'debug','	'.__FUNCTION__ .' statusmodule trouvé: ' .$datamodule['name'].'('.$moduleId.') : '.json_encode($infosModule));
                        $global[$homeid][$eqhome_Id]['energie_modules'][$moduleId]= $infosModule;
                      	$global[$homeid][$eqhome_Id]['energie_modules'][$moduleId]= $infosModule;
						//$global[$homeid][$eqhome_Id]['modules'][$plug_id]['modules_bridged'][] = $moduleId; //$infosModule;
                    }
                  	else{// !$datamodule || !$statusmodule
						$infosModule = $datamodule;
                        //log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' statusmodule introuvable: '                                 .$datamodule['name'].'('.$moduleId.')');
						continue;
					}
                }
              
            }
          	$home_eqmodules = $plugs;
          	
          	$global[$homeid][$eqhome_Id]['eqmodules']=json_encode($home_eqmodules, JSON_UNESCAPED_UNICODE);
          	if($st=3 == 3){
              	$data_schedules = isset($homeData['therm_schedules']) ? $homeData['therm_schedules'] : $homeData['schedules'];
              	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' data_schedules: '. json_encode($data_schedules));
                $getplanning = $this->getCalendar($data_schedules, null);
              	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' getplanning: '. json_encode($getplanning));  

                if($getplanning){
                if(!isset($global[$homeid][$eqhome_Id]['listplanning'])){
                    $global[$homeid][$eqhome_Id]['listplanning'] = $listplanning = $getplanning['planings']['listplanning'];
                    $global[$homeid][$eqhome_Id]['nowplanning'] = $nowplanning = $getplanning['planings']['nowplanning'];
                  	/*$global[$homeid][$eqhome_Id]['nowplanid'] = $nowplanid = =$apiHome[$homeid]['Data']['therm_schedule_current'];*/
                    $global[$homeid][$eqhome_Id]['nowplanid'] = $nowplanid = $getplanning['planings']['nowplanid'];
                    $global[$homeid][$eqhome_Id]['away_temp'] = $away_temp = $getplanning['planings']['away_temp'];	
                    $global[$homeid][$eqhome_Id]['hg_temp'] = $hg_temp = $getplanning['planings']['hg_temp'];	
                    $global[$homeid][$eqhome_Id]['plan_type'] = $plan_type = $getplanning['planings']['plan_type'];
                }
			
                //Profiles
              	if(!empty($getplanning['profils'])){
                  	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' getplanning[profils]: '.json_encode($getplanning['profils']));
						
                  	foreach ($getplanning['profils'] as $keyParam=>$profilParam){
                        $global[$homeid][$eqLog_id][$keyParam]=$getplanning['profils'][$keyParam];
                       	$global[$homeid][$eqLog_id]['nextprofil'] = $getplanning['profils']['nextprofil']
                          .'-'.$getplanning['profils']['nextprofil_temp'];
                        
                	}
                }
            }
            }
          	$home_modetech_endtime = isset($homeData['therm_mode_endtime']) ? date('d-m-Y H:i',$homeData['therm_mode_endtime']) : false;
          	if( !$home_modetech_endtime && $home_modetech != 'schedule')  $home_modetech_endtime = 'Nouvel Ordre';
          	$global[$homeid][$eqhome_Id]['setpointmode_endtime'] = $home_modetech_endtime;
          	$roomsCount=0;
          	foreach ($homeData['rooms'] as $roomData) {
              	$eqbatterie = [];
              	$eqroom_rf = [];
                            
              	/*if(!isset($roomData['therm_relay']) || !isset($roomData['modules']) 
                   	|| empty($roomData['modules']) || !isset($roomData['modules']) ){
                  	log::add('migoThermostat', 'debug','          '. __FUNCTION__ .' ***** Room...: '. $roomData['name']. ' >> Skiped');
                  	continue;
                }*/
              	if(!isset($roomData['module_ids']) || empty($roomData['module_ids'])){
                  	//log::add('migoThermostat', 'debug','	'. __FUNCTION__ .' ***** Room...: '. $roomData['name']. ' >> Skiped');
                  	continue;
                }
              	//log::add('migoThermostat', 'debug','	'. __FUNCTION__ .' ***** Room...: '. $roomData['name']. ' >> OK');
              	
              	$roomId = $roomData['id'];
              	$roomName = isset($homeStatus['name']) ? $roomData['name']:"";
              	$eqroom_Id = $roomId.'|'.$homeData['id'];
              	$key_room = isset($homeStatus['rooms']) ? array_search($roomId, array_column($homeStatus['rooms'], 'id')) : null;
                  	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' relai key_plug: '.$key_plug);
                    //$NAPlug_infos = array_merge($datamodule, $homeStatus['modules'][$key_plug] );
                  	//if ($key_room === null){//!is_null($key_room)
                    if(!is_null($key_room) && $key_room !== false){
                        $roomStatus = $homeStatus['rooms'][$key_room];
						//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ ." room status found _$key_room:".json_encode($roomStatus));
						$room_infos = array_merge($roomData, $roomStatus );
                      	if (!empty($roomStatus)){
                          	$room_infos['A_syncTime'] = date('d-m-Y H:i');
                           	$room_infos['Rqst_stauts'] = "ok";
                        }          
                      	
                    }else{
						$global[$homeid][$eqroom_Id]['id'] = $eqroom_Id;
              			$global[$homeid][$eqroom_Id]['name'] = $roomName;
              			$errMsg = "Piéce ($roomName) _Status indisponible sur l'Api";
                      	//$global[$homeid][$eqhome_Id]['errors'][] = $errMsg ;
                      	//$global[$homeid][$eqroom_Id]['errors'][]["room_status_Nok"] = $errMsg;
                      	$room_infos = $roomData;
                        $room_infos['errors'][2]["reachable_Nok"] = $errMsg;
                      	//log::add('migoThermostat', 'debug', '		'.__FUNCTION__ .' '.$errMsg. ' >> Skiping...');
                        continue;
                    }
              		if($is_room=1 == 1){
                      	$room_modesp = false;
                      	$global[$homeid][$eqroom_Id] = $room_infos;
                      	//$room_modetech = isset($room_infos['setpoint']['mode']) ? $room_infos['setpoint']['mode']:"";
                      	$room_modetech = isset($room_infos['therm_setpoint_mode']) ? $room_infos['therm_setpoint_mode']:"";
                      	if($room_modetech == 'home'){
                        	$room_modetech = $home_modetech;
                      	}
                      	elseif($room_modetech != "" && $room_modetech != $home_modetech){
                         	$global[$homeid][$eqhome_Id]['sp_room_mode'] = $room_modetech; 	
                          	$room_modesp = true;
                        }
                      	$global[$homeid][$eqroom_Id]['room_modetech'] = $room_modetech ;
                      	$global[$homeid][$eqroom_Id]['room_modesp'] = $room_modesp;
                      	  
                          
                        
                      
                      /******/
                        if( !isset($room_infos['reachable']) || $room_infos['reachable'] != true ){
                              $danger=true;
                              $errMsg ="La piéce(". $room_infos['name'].") est injoignable par l'Api";
                          		
                                      //.date('d-m-Y H:i',$room_infos['last_seen']);
                              //$alert_ar[1]="danger";
                              $global[$homeid][$eqroom_Id]['errors'][2]["reachable_Nok"] = $errMsg;
                          	//log::add('migoThermostat', 'warning', '		'.__FUNCTION__ .' '.$errMsg);
                            //log::add('migoThermostat', 'debug','	'. __FUNCTION__ .' ***** Room...: '. $roomData['name']. ' >> Skiped'); 
                          // continue;
                        }
                      
                      	$moduleInfos=[];//$moduleInfos
                      	$roomModules=[];
                      	$global[$homeid][$eqroom_Id]['modules'] = [];
                      	$plugofRoom_Id = $room_infos['therm_relay'];
                        if(isset($global[$homeid][$eqhome_Id]['modules'][$plugofRoom_Id]['reachable'])
                              && $global[$homeid][$eqhome_Id]['modules'][$plugofRoom_Id]['reachable'] != true){
							$naplug_room = $global[$homeid][$eqhome_Id]['modules'][$plugofRoom_Id];
                      		$naplug_last_seen = isset($naplug_room['last_seen']) ? " depuis: ".date('d-m-Y H:i', $naplug_room['last_seen']) : "";
                          	$errMsg = "_Relai(".$naplug_room['name'].") injoignable par l'Api".$naplug_last_seen;
                              
                      		$global[$homeid][$eqroom_Id]['errors'][0]['plug_reachable_Nok'] = $errMsg;
                          	//$global[$homeid][$eqroom_Id]['errors'][3]['pl_reachable_Nok'] = $errMsg;
                      		//log::add('migoThermostat', 'warning', '		'.__FUNCTION__ .' '.$errMsg ); 
                      	}  
                       	
                      	$modulesCount=0;
                      	foreach ($room_infos['modules'] as $roomModuleId) {
                          	if(!isset($global[$homeid][$eqhome_Id]['energie_modules'][$roomModuleId])){
                              	continue;
                            }
                          	$moduleInfos = $global[$homeid][$eqhome_Id]['energie_modules'][$roomModuleId];
                          	
                          
                          	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ ." $eqroom_Id room moduleInfos: ".json_encode($moduleInfos));
                          	$battery_state = isset($moduleInfos['battery_state']) ? $moduleInfos['battery_state'] : null;
                          	if( $battery_state == 'low' || $battery_state == 'very_low' ){
                              	$global[$homeid][$eqroom_Id]['battery_'.$battery_state][]=$roomModuleId;
                            }
                            if( $moduleInfos['reachable'] != true ){
                                $danger = true;
                                $Mod_last_seen = (isset($moduleInfos['last_seen'])) ? ' depuis: '.date('d-m-Y H:i', $moduleInfos['last_seen']) : "";
								$errMsg = 'Le module '.$moduleInfos['name']. ' est injoignable'.$Mod_last_seen;
                              	
                                $alert_ar[1]="danger";
                                $global[$homeid][$eqroom_Id]['errors'][1]["module_reachable_Nok"] = $errMsg;
                                //log::add('migoThermostat', 'warning', '		'.__FUNCTION__ .' '.$errMsg);
                        	}
                          
                          	$battery_percent = null;
                          	if(isset($moduleInfos['battery_level']) && $moduleInfos['reachable'] == true){
                                $battery_percent = $this->getBattery($moduleInfos['battery_level'], $moduleInfos['type'], $battery_state);
                                $moduleInfos['battery_percent'] = $battery_percent;
                              	if($battery_percent <= 15){//$batterie &&
                                    $battErrMsg = "La batterie du module ".$moduleInfos['name']
                                      ." est trop faible '$battery_percent%' - Piéce: ".$room_infos['name']."||";
                                    $global[$homeid][$eqroom_Id]['errors'][4]["batterie_danger"] = $battErrMsg;
                                }
                                elseif($battery_percent <= 25){//$batterie &&
                                      
                                    $battErrMsg = "La batterie du module ".$moduleInfos['name']." est faible '$battery_percent%' - Piéce: ".$room_infos['name'];
                                    $global[$homeid][$eqroom_Id]['errors'][4]["batterie_warning"] = $battErrMsg;
                                  
                                  //$arMsg[4] = substr($battErrMsg, 0, -2);
                                   // $alert_ar[4] = "warning";
                                    //log::add('migoThermostat', 'warning','|	'.__FUNCTION__ ." ".$battErrMsg);
                                }
                            }
                          	//$eqbatterie[] = $battery_percent;//is_null($battery_percent) ? 0 : $battery_percent;
                          	!is_null($battery_percent) ? $eqbatterie[] = $battery_percent :"";
                          
                          
                  	
                          	$rf_strength = isset($moduleInfos['rf_strength']) ? $moduleInfos['rf_strength'] : null;
                          	$moduleInfos['rfpower'] = $rfpower = $this->getrfstate($rf_strength);//add % to $eqmodules
                          	$eqroom_rf[] = is_null($rf_strength) ? 0 : $rf_strength;
                            $global[$homeid][$eqroom_Id]['modules'][] = $moduleInfos;
                          	unset($moduleInfos['event_history']);
                          	unset($moduleInfos['calibration_error']);
                          	unset($moduleInfos['motor_voltage_drop']);
                          	unset($moduleInfos['motor_frequency']);
                          	unset($moduleInfos['v_motor']);
                          	$roomModules[] = $moduleInfos;
                      
                          
                          	if( isset($moduleInfos['boiler_status']) ){
                                $boiler_status = $moduleInfos['boiler_status'];
                                if($boiler_status == true){
                                    $global[$homeid][$eqroom_Id]['boiler_status'] = true;
                                  	$global[$homeid][$eqhome_Id]['boiler_status'] = true;
                                  	$global[$homeid][$eqroom_Id]['actif'] = true;
                                  
                                }
                            }
                          
							if( isset($moduleInfos['anticipating']) && $moduleInfos['anticipating'] == true){
                                $global[$homeid][$eqhome_Id]['boiler_anticipating'] = true;
                                $global[$homeid][$eqroom_Id]['room_anticipating'] = true;
                                //$global[$homeid][$eqroom_Id]['actif'] = true;
                            }
                          
                          
                          	
                          	
                          
                        
                        	$modulesCount++;
                        }//foreach ($room_infos['modules']
                      	$global[$homeid][$eqroom_Id]['modulesCount']=$modulesCount;
                      
                      	$global[$homeid][$eqroom_Id]['eqmodules'] = json_encode($roomModules, JSON_UNESCAPED_UNICODE);
                      	$room_rf_strength = min($eqroom_rf);
              			$room_rf = $this->getrfstate($room_rf_strength);
				
                      	$global[$homeid][$eqroom_Id]['batterie'] = !empty($eqbatterie) ? min($eqbatterie) : "";
                      	$global[$homeid][$eqroom_Id]['room_rf'] = $room_rf;
                      ////////////////
                     
                      	if($st=5 == 5){
                          	$data_schedules = isset($homeData['schedules']) ? $homeData['schedules'] : $homeData['therm_programs'];
              				//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' data_schedules: '. json_encode($data_schedules));
                			$getRplanning = $this->getCalendar($data_schedules, $roomId);
                            //log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' getRplanning-profil: '. json_encode($getRplanning['profils']));  

                            if($getRplanning){
                                //Profiles
                                if(!empty($getRplanning['profils'])){
                                    foreach ($getRplanning['profils'] as $keyParam=>$profilParam){
                                        $global[$homeid][$eqroom_Id][$keyParam]=$getRplanning['profils'][$keyParam];
                                        $global[$homeid][$eqroom_Id]['nextprofil'] = $getRplanning['profils']['nextprofil']
                                              .'-'.$getRplanning['profils']['nextprofil_temp'];



                                    }
                                    $profil_endtime = $getRplanning['profils']['profil_endtime'];
                                    $nextprofil_tendance = $getRplanning['profils']['nowprofil_temp'] - $getRplanning['profils']['nextprofil_temp'];
                                    $global[$homeid][$eqroom_Id]['nextprofil_tendance'] = $nextprofil_tendance;
                                }

                            }
                        }
                      	
                      
                      	if (isset($room_infos['therm_setpoint_start_time']) && $room_infos['therm_setpoint_start_time'] != null){
                            $spRoom_starttime = date('d-m-Y H:i',$room_infos['therm_setpoint_start_time']);
                        } elseif (isset($room_infos['setpoint']['starttime']) && $room_infos['setpoint']['starttime'] != null){
                            $spRoom_starttime = date('d-m-Y H:i', $room_infos['setpoint']['starttime']);
                        }
                      	else{
                            $spRoom_starttime = null;
                        }
                      	$global[$homeid][$eqroom_Id]['spRoom_starttime'] = $spRoom_starttime;
                      
                      	if (isset($room_infos['therm_setpoint_end_time']) && $room_infos['therm_setpoint_end_time'] != null){
                            //$global[$homeid][$eqhome_Id]['setpointmode_endtime'] = $setpointmode_endtime;
                            //$setpointmode_endtime=date('d-m-Y H:i',$room_infos['therm_setpoint_end_time']);
                            //$global[$homeid][$eqLog_id]['setpointmode_endtime'] = $setpointmode_endtime; 
                            $spRoom_endtime = date('d-m-Y H:i',$room_infos['therm_setpoint_end_time']);
                            $global[$homeid][$eqroom_Id]['spRoom_endtime'] = $spRoom_endtime;
                          //$room_infos['spRoom_endtime'] = $spRoom_endtime;
							
                            //room_modetech=='hg' && 0 > 'Nouvel Ordre'
                        }
                        elseif($room_modetech == 'schedule'){
                          	$setpointmode_endtime = $global[$homeid][$eqroom_Id]['profil_endtime'];
                          	$global[$homeid][$eqroom_Id]['spRoom_endtime'] = $setpointmode_endtime;
                            $global[$homeid][$eqhome_Id]['setpointmode_endtime'] = $setpointmode_endtime;
                          	
                        }
                      	elseif($home_modetech_endtime && $room_modetech == $home_modetech){
                        	$global[$homeid][$eqroom_Id]['spRoom_endtime'] = $home_modetech_endtime;
                       } 
                      	elseif($room_modetech == 'hg' || $room_modetech == 'away'){
                          	$spRoom_endtime='Nouvel Ordre';
                          	$global[$homeid][$eqroom_Id]['spRoom_endtime'] = $spRoom_endtime;
                            //$global[$homeid][$eqhome_Id]['setpointmode_endtime'] = $spRoom_endtime;
                        } 
                      	elseif($room_modetech == 'home'){
                          	$spRoom_endtime='Nouvel Ordre';
                          	$global[$homeid][$eqroom_Id]['spRoom_endtime'] = $spRoom_endtime;
                            $global[$homeid][$eqhome_Id]['setpointmode_endtime'] = $spRoom_endtime;
                        }
                      	else{
                          	$spRoom_endtime='unkn';
                          	$global[$homeid][$eqroom_Id]['spRoom_endtime'] = $spRoom_endtime;
                            $global[$homeid][$eqhome_Id]['setpointmode_endtime'] = $spRoom_endtime;
                        }
                  		//$global[$homeid][$eqroom_Id]['spRoom_endtime'] = $spRoom_endtime;
                        
                      
                        if ( isset($room_infos['therm_measured_temperature']) ){
                            $global[$homeid][$eqroom_Id]['temperature'] = $room_infos['therm_measured_temperature'];
                            unset($global[$homeid][$eqroom_Id]['therm_measured_temperature']);
                        }
                      	elseif ( isset($room_infos['temperature']) ){
                            $global[$homeid][$eqroom_Id]['temperature'] = $room_infos['temperature'];
                            //unset($global[$homeid][$eqroom_Id]['temperature']);
                        }
                        
                      	if ( isset($room_infos['therm_setpoint_temperature']) ){
                            $global[$homeid][$eqroom_Id]['consigne'] = $room_infos['therm_setpoint_temperature'];
                            unset($global[$homeid][$eqroom_Id]['therm_setpoint_temperature']);
                        }
                      	elseif ( isset($room_infos['setpoint']['temperature']) ){
                            $global[$homeid][$eqroom_Id]['consigne'] = $room_infos['setpoint']['temperature'];
                            unset($global[$homeid][$eqroom_Id]['setpoint']['temperature']);
                        }
                        
                      	if ( isset($room_infos['anticipating']) ){
                          	$room_anticipating = $room_infos['anticipating'];
                            $global[$homeid][$eqroom_Id]['room_anticipating'] = $room_anticipating;
                          	if($room_anticipating == 1) {
                                //$global[$homeid][$eqroom_Id]['actif'] = true;
                              	$global[$homeid][$eqhome_Id]['boiler_anticipating'] = true;
                              
                            }
                            unset($global[$homeid][$eqroom_Id]['anticipating']);
                        }
                        
                      	if (isset($room_infos['heating_power_request'])){
                            $global[$homeid][$eqroom_Id]['powerRequest'] = $powerRequest = $room_infos['heating_power_request'];
                            if($powerRequest >= 1) {
                                $global[$homeid][$eqroom_Id]['actif'] = true;
                              	$global[$homeid][$eqhome_Id]['boiler_status'] = true;
                            }
                            unset($global[$homeid][$eqroom_Id]['heating_power_request']);

                        }
                      
                    }
              		if(!isset($global[$homeid][$eqroom_Id]['actif'])){
                         $global[$homeid][$eqroom_Id]['actif'] = false;
                      	 $global[$homeid][$eqroom_Id]['statustr'] = "Eteint";
                    }else{
                       $global[$homeid][$eqroom_Id]['statustr'] = "Allumé";
                    }
              
            
            $roomsCount++;
                    
            }//foreach ($homeData['rooms']
          	$global[$homeid][$eqhome_Id]['roomsCount']=$roomsCount;
        }	
      
      	$global['apiHome']=$apiHome;
        return $global;
    }
  	public function _syncHomeStatus($home_id, $device_types = array()){//
        $params = [
          'home_id' => $home_id,
          'device_types' => DTYPE,
       	];
      	return $this->api('https://app.netatmo.net/syncapi/v1/homestatus', 'POST', $params);
    }
	
	public function _Homesdata($home_id=NULL){
      	$user_prefix = $this->getVariable('user_prefix');
		$params = [
					"gateway_types"=>DTYPE,
					"detailed_config"=>TRUE,
					"gateway_parameters"=>["NAVaillant"=>["sync_measures"=>TRUE]],
					"data_amount"=>"app",
					"sync_measures"=>TRUE,
					"app_type"=>"app_thermostat_".$user_prefix,
        ];
		
      	if(!is_null($home_id)) $params['home_id'] = $home_id ;
      	return $this->api('homesdata', 'POST', $params);
    }
///////////////////////////////	
	public function getCalendar($proglist, $roomid=null) {
      	//log::add('migoThermostat','debug', '		'.__FUNCTION__ .' start... ');
		if(empty($proglist)){
          return null;
        }
      
      	$nowplanning='';
		$nowplanid='';
		$nowprofil ='Aucun';
		$nextprofil ='Aucun';
		$profil_endtime ='';
		$listplanning='';
		$listprofil='';
      	$now=time();
	///////// Liste des plannings et planning en cours
		foreach ($proglist as $keyplan => $plan) {
			//$status=(isset($plan['selected'])) ? "TRUE" : "FALSE";//////<<? "YES" : "NO";
			$plan_type = $plan['type'];// therm, event
            if (isset($plan['selected']) && $plan['selected'] == TRUE && $plan_type=='therm'){//////<<?
				//Planning actif
				$keyGoodplan=$keyplan;
				$nowplanning=$plan['name'];
				$nowplanid=$plan['id'];
              	$away_temp = isset($plan['away_temp']) ? $plan['away_temp'] : "";
				$hg_temp = isset($plan['hg_temp']) ? $plan['hg_temp'] : "";
				
			}
			$listplanning=$listplanning . $plan['id'] . '|' . $plan['name'] . ';';
		}
		
      	
      	$nowoffset=floor( ($now-date(strtotime('Monday this week')) )/60);//
		$nbtime=count($proglist[$keyGoodplan]["timetable"]);
		$actifplan=$proglist[$keyGoodplan];
      	
	///////// Profil actif et profil suivant $plan["timetable"][0]["zone_id"];
		//log::add('migoThermostat', 'debug','		'.__FUNCTION__ .' actifplan : '. json_encode($actifplan));
      	$profils=[];
        if($roomid != null){
          	foreach ($actifplan["timetable"] as $key => $time) {
			if ($time["m_offset"] >= $nowoffset){
				//Pendant la semaine
              	$nextgoodkey = $key;
              	$nowgoodkey = ($nextgoodkey>0) ? $key-1 : $key;
              	
				$nextprofil_id = $time["zone_id"];
				$nowprofil_id = $actifplan["timetable"][$nowgoodkey]["zone_id"];
				$profil_offset = $time["m_offset"];
              	break;
			} elseif ($key == ($nbtime-1)){
				//Derniere plage de la semaine
              	$nowgoodkey = $nbtime-1;
				$nowprofil_id = $actifplan["timetable"][$nowgoodkey]["zone_id"];
              	//log::add('migoThermostat','debug', ''.__FUNCTION__ .' 696 '.$nowprofil_id." ".$actifplan["timetable"][0]["zone_id"]);
                  	
				if($actifplan["timetable"][0]["zone_id"] == $nowprofil_id && isset($actifplan["timetable"][1]) ){
                  	//log::add('migoThermostat','debug', ''.__FUNCTION__ .' 692 ');
                   	$nextprofil_id = isset($actifplan["timetable"][1]["zone_id"]) ? $actifplan["timetable"][1]["zone_id"]:false;
					$profil_offset = $actifplan["timetable"][1]["m_offset"]+7*24*60;
				}else{
					//log::add('migoThermostat','debug', ''.__FUNCTION__ .' 696 '.$nowprofil_id." ".$actifplan["timetable"][0]["zone_id"]);
                  	$nextprofil_id = $nowprofil_id;//$actifplan["timetable"][0]["zone_id"];
					$profil_offset = $actifplan["timetable"][0]["m_offset"]+7*24*60;
				}
			}
		}
      		//log::add('migoThermostat','debug', ''.__FUNCTION__ .' profil_offset: '.$profil_offset);
            if ($profil_offset == 10080) {
                $firstday=date(strtotime('Monday this week'));
            }elseif ($profil_offset != 0) {
                $firstday=date(strtotime('Monday this week'));
            }else{//semaine prochaine
                $firstday=date(strtotime('Monday this week +6 days'));
            }
                //$firstday=date(strtotime('Monday this week'));					
            $profil_endtime = date($firstday + $profil_offset*60);
            //log::add('migoThermostat','debug', ''.__FUNCTION__ .' profil_endtime: '.$profil_endtime.' '.date('d-m-Y H:i', $profil_endtime));
            /*if ($profil_endtime == '') {
                    $profil_endtime='00:00';
                }*/	

        ///////// Liste des profils/profil actif-suivant/temp
        foreach ($actifplan["zones"] as $key => $zone) {
			foreach ($zone["rooms_temp"] as $key => $roomtemp) {
            	if($roomtemp["room_id"] == $roomid){
                	//log::add('migoThermostat','debug', '		'.__FUNCTION__ .' roomid: '.$roomid.' # '.$roomtemp["room_id"].' -- '.$roomtemp['temp']);
              		$zone_temp=$roomtemp['temp'];
                    if ( isset($zone['name']) ) {	
                        $profilname = $zone['name'].';'.$zone_temp;
                    }
                  	else{
                        if ($zone['type'] == 0) {
                            $profilname = 'Home'.';'.$zone_temp;
                        }elseif ($zone['type'] == 1) {
                            $profilname = 'Nuit'.';'.$zone_temp;
                        }elseif ($zone['type'] == 3) {
                            $profilname = 'HG'.';'.$zone_temp;
                        }elseif ($zone['type'] == 5) {
                            $profilname = 'Absent'.';'.$zone_temp;
                        }else{
                            $profilname = 'Profile T° '.$zone_temp.';'.$zone_temp;
                        }
                    }
                    $listprofil=$listprofil.$profilname .'|';

                    ///////////////////////
                    if ($zone['id'] == $nowprofil_id) {
                        list($nowprofil, $nowprofil_temp) = explode(';', $profilname);
                    } //else
                    if ($zone['id'] == $nextprofil_id) {
                        list($nextprofil, $nextprofil_temp) = explode(';', $profilname);
                    }
              	}//fin if($roomtemp["room_id"] == $roomid)
            }//fin foreach ($zone["rooms_temp"] as $key => $roomtemp
		}
          	$profils['listprofil']=substr($listprofil, 0, -1);//$listprofil;
            $profils['nowprofil']=$nowprofil;
            $profils['nowprofil_temp']=$nowprofil_temp;
            $profils['nextprofil']=$nextprofil;
            $profils['nextprofil_temp'] = isset($nextprofil_temp) ? $nextprofil_temp : null ;
            $profils['profil_endtime']=date('d-m-Y H:i', $profil_endtime);
            $profils['nextprofil_delay']=floor(($profil_endtime-$now)/60);
        }
      	
		//fin foreach ($actifplan["zones"] as $key => $zone
      	//log::add('migoThermostat','debug', '		'.__FUNCTION__ .' listprofil: '.$listprofil);
      	$planings['listplanning']=substr($listplanning, 0, -1);//$listplanning;
      	$planings['nowplanning']=$nowplanning;
		$planings['nowplanid']=$nowplanid;
		$planings['away_temp']=$away_temp;	
		$planings['hg_temp']=$hg_temp;//hg_temp	
		$planings['plan_type']=$plan_type;
		
      	
      	
		return ['planings'=>$planings, 'profils'=>$profils];
      
      
	}
///////////////////////////////	
	public function getrfstate($signal) {
		if($signal >= 90) return 'very_low';
		if($signal >= 80) return 'low';
		if($signal >= 70) return 'medium';
		if($signal >= 60) return 'high';
		return 'full';
	}
///////////////////////////////	
	public function getBattery($battery_vp, $type, $battery_state = "") {
        if($type == 'NRV'){
            switch($battery_state){	//Thermostat
                case "very_low" : $coef = 1.4; $state_percent = 10;  2680; break;
                case "low": $coef = 1.3; $state_percent = 20;  break;
                case "medium" :  $coef = 1.2; $state_percent = 40; break;
                case "high" : $coef = 1.1; $state_percent = 70; break;
                case "full" : $coef = 1; $state_percent = 90; break;
                default : $coef = 1; $state_percent = -100;  break;
            }	
            $bat_min = 2600; $bat_max = 3200;
         }elseif($type == 'NATherm1' || $type == 'OTM' || $type ==  'NAThermVaillant'){
              $state_percent = 100;
              $bat_min =3000;//3000
              $bat_max =4500;//4500
        }else{
              log::add('migoThermostat', 'warning', __FUNCTION__ .' undefined type: '. $type);
              return null;
        }
          $value = round(($battery_vp - $bat_min)*100/($bat_max - $bat_min), 0);
          //$value=round(($state_percent - $calc/100), 0);
          //$value= round(100-($bat_max-$battery_vp)*98/$bat_min, 0);

          //log::add('migoThermostat', 'debug','|	'. __FUNCTION__ .' '. $battery_vp .'|'. $battery_state.' = '.$value.'%'.' ('.$bat_min.'/'.$bat_max.' )');
          if($battery_state == "") $return = null;
          elseif($value <= 0) $return = $state_percent;
          elseif($value >= 100 && $battery_state == "full" ) $return = 100;
          elseif($value > $state_percent) $return = round($state_percent + ($state_percent + $value)/20, 0);
          elseif($value < $state_percent) $return = round($state_percent - ($state_percent + $value)/20, 0);
          else $return = $value;

          /*log::add('migoThermostat', 'debug','|	'. __FUNCTION__ .' '. $battery_vp .'|'. $battery_state.' = '.$return.'%'.' ('.$bat_min.'/'.$bat_max.' )' .(($return != $value) ? " $value=>$return" : "" )." state_percent: $state_percent" );*/

        return $return;
  
}
///////////////////////////////	
	public function get_naWifi($wifi) {
		if($wifi >= 100)return 'very_low';
		if($wifi >= 86) return 'low';    
		if($wifi >= 71) return 'medium';
		if($wifi >= 60) return 'high';   
		return 'full';
	}
  
///////////////////////////////	
	public function getVtMesure($device_id, $module_id, $scale=NULL, $type=NULL, $date_begin=NULL, $date_end=NULL, $limit=NULL,  $optimize=NULL, $realtime=NULL){
		
		$params = array('device_id' => $device_id,
						'module_id' => $module_id,
						'app_version'=>"1.4.0.1");
		////
		$optionals = array(
			'scale' => $scale,//"max",
			'type' => $type,//"boileron,boileroff",
			'date_begin' => $date_begin,
			'date_end' => $date_end,//"last",
			'limit' => $limit,
			'optimize' => $optimize,
			'real_time' => $realtime);
		
		
		
		foreach ($optionals as $key => $value) {
			if (!is_null($value)) {
				$params[$key] = $value;
			}

		}
		////
		return $this->api('getmeasure', 'GET', $params);
	}
	
			
		
	public function getMeasure($device_id, $module_id, $scale, $type, $start = NULL, $end = NULL, $limit = NULL, $optimize = NULL, $realtime = NULL) {
		$params = array(
			'device_id' => $deviceid,
			'module_id' => $moduleid,
			'scale' => $scale,
			'type' => $type);

		$optionals = array(
			'date_begin' => $start,
			'date_end' => $end,
			'limit' => $limit,
			'optimize' => $optimize,
			'real_time' => $realtime);
		foreach ($optionals as $key => $value) {
			if (!is_null($value)) {
				$params[$key] = $value;
			}

		}

		return $this->api('getmeasure', 'GET', $params);
	}
	///////////////
	private function setMinorMode($device_id, $module_id, $mode, $activate, $endtime = NULL, $temperatureset = NULL) {
		$params = array('device_id' => $device_id,
						'module_id' => $module_id,
						'setpoint_mode' => $mode,//hwb/away/manual
						'activate' => $activate,//true/false
						'app_version' => "1.4.0.1");

		if (!is_null($endtime)) {
			$params['setpoint_endtime'] = $endtime;
		}

		if (!is_null($temperatureset)) {
			$params['setpoint_temp'] = $temperatureset;
		}

		return $this->api('setminormode', 'POST', $params);
	}
		/*
	* @setHwTemp
	*/
///////////////////////////////************************/////////////////////////////////////////

	private function setHotWaterTemp($deviceid,$temperaturesethw) {
		$params =array('device_id' => $deviceid,'dhw' => $temperaturesethw);
			
		return $this->api('sethotwatertemperature', 'POST', $params);
		
	}
	////////////////
	private function setHwTemp($deviceid,$temperaturesethw) {
		
		return $this->setHotWaterTemp($deviceid,$temperaturesethw);	
	}
	
	/////////////////////////////set Hwb Boost
	public function setHwbBoost($device_id, $module_id, $activate, $endtime = NULL) {
		return $this->setMinorMode($device_id, $module_id, 'hwb', $activate, $endtime);
	}

	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param float $temperatureset
	 * @param timestamp (utc) $endtime (optional)
	 * @brief Sets a manual temperature to the given thermostat for a specified amount of time
	 */
	
///////////////////////////////************************/////////////////////////////////////////
		/* boiler Mode winter /summer /frrostguard*/
	private function setSystemMode($device_id, $module_id, $sysmode) {
		$params = array('device_id' => $device_id,
						'module_id' => $module_id,
						'system_mode' => $sysmode,//winter/summer/frostguard
						'app_version' => "1.4.0.1");

		return $this->api('setsystemmode', 'POST', $params);
	}
	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param timestamp (utc) $endtime (optional)
	 * @brief Sets the given thermostat to away mode until the given date or until change.
	 */
	public function setToAwayMode($device_id, $module_id, $activate, $endtime = NULL) {
		return $this->setMinorMode($device_id, $module_id, 'away', $activate, $endtime);
	}				  
	
	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param float $temperatureset
	 * @param timestamp (utc) $endtime (optional)
	 * @brief Sets a manual temperature to the given thermostat for a specified amount of time
	 */
	public function setToManualMode($device_id, $module_id, $activate, $temperatureset= NULL, $endtime = NULL) {
		return $this->setMinorMode($device_id, $module_id, 'manual', $activate, $endtime, $temperatureset);
	}				
	
////////////////////////////////////////////////////////////////////////////////////////////
/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param timestamp (utc) $endtime (optional)
	 * @brief Sets the given thermostat to frost-guard mode until the given date or until change
	 */
	public function setMasterMode($device_id, $module_id, $syssetmode) 
	{
		return $this->setSystemMode($device_id, $module_id, $syssetmode);
	}
/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param timestamp (utc) $endtime (optional)
	 * @brief Sets the given thermostat to frost-guard mode until the given date or until change
	 */
	public function setToFrostGuardMode($device_id, $module_id, $endtime = NULL) 
	{
		return $this->setSystemMode($device_id, $module_id, 'frostguard', $endtime);
	}
	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @brief Turn off the given thermostat
	 */
	public function turnOff($device_id, $module_id)
	{
		return $this->setSystemMode($device_id, $module_id, 'frostguard');
		//return $this->setSystemMode($device_id, $module_id, 'summer');
	}
	
	public function setToWinter($device_id, $module_id) 
	{
		return $this->setSystemMode($device_id, $module_id, 'winter');
	}
	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @brief Order the given thermostat to follow its schedule
	 */
	public function setToProgramMode($device_id, $module_id) {
		return $this->setMinorMode($device_id, $module_id, 'manual', 'false');//set manual off
		return $this->setMinorMode($device_id, $module_id, 'away', 'false');//set away off
		//return $this->setMinorMode($device_id, $module_id, 'program','true');//set program true
	}

	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param timestamp(utc) $endtime
	 * @brief Order the given thermostat to heat to its max temperature
	 */
	public function setToMaxMode($device_id,$hwmaxtemp=null) {
		return $this->setHotWaterTemp($device_id, '60');
	}

	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param array  $zones
	 * @param array $timetable
	 * @param string $name
	 * @brief Create a new heating schedule for the given thermostat
	 */
	public function createSchedule($device_id, $module_id, $zones, $timetable, $name) {
		$params = array('device_id' => $device_id,
			'module_id' => $module_id,
			'zones' => $zones,
			'timetable' => $timetable,
			'name' => $name);
		return $this->api('createnewschedule', 'POST', $params);
	}

	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param string $schedule_id
	 * @brief switch to the given existing heating schedule
	 */
	public function changeSchedule($device_id, $module_id, $schedule_id) {
		$params = array('device_id' => $device_id,
			'module_id' => $module_id,
			'schedule_id' => $schedule_id);
		return $this->api('switchschedule', 'POST', $params);
	}

	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $device_id
	 * @param string $schedule_id
	 * @param string $name
	 * @brief Rename an existing heating schedule
	 */
	public function renameSchedule($device_id, $module_id, $schedule_id, $name) {
		$params = array('device_id' => $device_id,
			'module_id' => $module_id,
			'schedule_id' => $schedule_id,
			'name' => $name);
		return $this->api('renameschedule', 'POST', $params);
	}

	/* 
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param string $schedule_id
	 * @brief Delete the given heating schedule. Beware, there should always be at least one schedule left for the device.
	 */
	public function deleteSchedule($device_id, $module_id, $schedule_id) {
		$params = array('device_id' => $device_id,
			'module_id' => $module_id,
			'schedule_id' => $schedule_id);
		return $this->api('deleteschedule', 'POST', $params);
	}

	/*
	 * @type PRIVATE & PARTNER API
	 * @param string $device_id
	 * @param string $module_id
	 * @param array $zones
	 * @param array $timetable
	 * @brief change the thermostat's heating schedule the given one
	 */
	public function syncSchedule($device_id, $module_id, $zones, $timetable) {
		$params = array('device_id' => $device_id,
			'module_id' => $module_id,
			'zones' => $zones,
			'timetable' => $timetable);
		return $this->api('syncschedule', 'POST', $params);
	}

}
?>