<?php

/* This file is part of Jeedom.
 *
 * Jeedom is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Jeedom is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Jeedom. If not, see <http://www.gnu.org/licenses/>.
 */
 
 

try {
	require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';
	require_once dirname(__FILE__) . '/../../../migoThermostat/core/class/migoThermostat.class.php';
	include_file('core', 'authentification', 'php');

	if (!isConnect('admin')) {
		throw new Exception(__('401 - Accès non autorisé...', __FILE__));
	}

ajax::init();
$action = init('action');

	if ($action == 'getThermostat') {
		if (init('object_id') == '') {
			$_GET['object_id'] = $_SESSION['user']->getOptions('defaultDashboardObject');
		}
		$object = jeeObject::byId(init('object_id'));
		if (!is_object($object)) {
			$object = jeeObject::rootObject();
		}
		if (!is_object($object)) {
			throw new Exception(__('Aucun objet racine trouvé', __FILE__));
		}
		if (count($object->getEqLogic(true, false, 'migoThermostat')) == 0) {
			$allObject = object::buildTree();
			foreach ($allObject as $object_sel) {
				if (count($object_sel->getEqLogic(true, false, 'migoThermostat')) > 0) {
					$object = $object_sel;
					break;
				}
			}
		}
		$return = array('object' => utils::o2a($object));

		$date = array(
			'start' => init('dateStart'),
			'end' => init('dateEnd'),
		);

		if ($date['start'] == '') {
			$date['start'] = date('Y-m-d', strtotime('-1 months ' . date('Y-m-d')));
		}
		if ($date['end'] == '') {
			$date['end'] = date('Y-m-d', strtotime('+1 days ' . date('Y-m-d')));
		}
		$return['date'] = $date;
		foreach ($object->getEqLogic(true, false, 'migoThermostat') as $eqLogic) {
			$return['eqLogics'][] = array('eqLogic' => utils::o2a($eqLogic), 'html' => $eqLogic->toHtml(init('version')), 'runtimeByDay' => array_values($eqLogic->runtimeByDay($date['start'], $date['end'])));
		}
		ajax::success($return);
	}

	
	if ($action == 'connectMigo'){
		migoThermostat::connectMigo('ajax');
		ajax::success();
     	// migoThermostat::cron10()
	}
	
	if ($action == 'syncData'){
		migoThermostat::connectMigo('ajax');
		ajax::success(migoThermostat::cron10());
	}
///////////////////////////////////////////Graph
	if ($action == 'getDataG') {
        log::add('migoThermostat', 'debug', 'action getDataG ajax'.init('device_id').init('module_id'));
        $return = migoThermostatGraph::getDataGraph(init('device_id'),init('module_id'),init('scale'),init('type'),init('date_begin'),init('date_end'),init('limit'),init('subtitle'),init('real_time'));
		ajax::success($return);
		log::add('migoThermostat', 'debug', 'fff' .$return);
		
    }
//////////    
	if ($action == 'getData') {
		$type = init('type');
		$path = dirname(__FILE__) . '/../../data/' . $type . '.json';
		if (!file_exists($path)) {
			log::add('migoThermostat', 'debug', 'fichier introuvable');
			return array();
		}	else {
			log::add('migoThermostat', 'debug', 'fichier ok');
		}
		com_shell::execute(system::getCmdSudo() . 'chmod 777 ' . $path) ;
		$lines = explode("\n", trim(file_get_contents($path)));
		$result = array();
		foreach ($lines as $line) {
			$result[] = json_decode($line, true);
		}
		ajax::success($result);
	}
  //////////    
	if ($action == 'getStoredData') {
		$type = init('type');
		log::add('migoThermostat', 'debug', 'getStoredData '.$type);
      	$path = dirname(__FILE__) . '/../../data/' . $type . '.json';
		if (!file_exists($path)) {
			log::add('migoThermostat', 'debug', 'fichier introuvable');
          	migoThermostatGraph::writedataStat();
          	ajax::error('Donées pas encore disponibles réesayer plus tard');
          //throw new Exception('fichiers data introuvable  ' . $action);
			//return array();
		}else {
			$contents = file_get_contents($path);//trim(file_get_contents($path)));
      		$result = json_decode($contents,true);
			log::add('migoThermostat', 'debug', 'fichier ok '.$contents);
		}
      	/*com_shell::execute(system::getCmdSudo() . 'chmod 777 ' . $path) ;
		$lines = explode("\n", trim(file_get_contents($path)));
		$result = array();
		foreach ($lines as $line) {
			$result[] = json_decode($line, true);
		}*/
		ajax::success($result);
	}
///////////////////
	if ($action == 'cronHourly') {
		migoThermostat::cronHourly();
		ajax::success();
	}
//////////////////	





	throw new Exception(__('Aucune methode ne correspondante à : ', __FILE__) . $action);
	/*     * *********Catch exeption*************** */
} catch (Exception $e) {
	ajax::error(displayExeption($e), $e->getCode());
}

?>