<?php
//error_reporting(E_ALL);

require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';

if (!class_exists('VTApiClient')) {
	require_once dirname(__FILE__) . '/../../../migoThermostat/3rdparty/Migo/autoload.php';
}

if (!class_exists('migoThermostatGraph')) {
	require_once dirname(__FILE__) . '/migoThermostatGraph.php';
}
if (!class_exists('migoThermostat_W') && file_exists(__DIR__ . '/migoThermostat_W.class.php')) {
	require_once __DIR__ . '/migoThermostat_W.class.php';
}


class migoThermostat extends eqLogic {
	/*     * *************************Attributs****************************** */
	private static $_client = null;
	
	public static $_data = array();
	public static $_conf = array();
	protected $_migo_user;	
	public static $_widgetPossibility = array('custom' => true);
  	private static $_globalConfig = null;
	private static $_token;
	public static $_isMaster = false;
    
	/////////////////////////////////////*********************///////////////////////////////////// 
    public static function removeAll(){
        log::add('migoThermostat', 'debug', __FUNCTION__ . ' start ');
        $eqLogics = migoThermostat::byType('migoThermostat', false);
        foreach ($eqLogics as $eqLogic) {
            $eqLogic->remove();
        }
        config::remove('homes', __CLASS__);
      	return array(true,'remove ok');//'remove ok'
    }
////////*****************************************////////
	public static function unsubscribeWebhook() {
      	$client = self::getClient('int');
      	$app_type = "app_thermostat_".config::byKey('th_type', 'migoThermostat');
      	
      	$params = array('app_type' => $app_type);//"app_energy","app_thermostat","app_all"
      	try{
			$Unsubscribe_naWebhook = $client->api('dropwebhook', $params);
		}
        catch (Exception $ex) {
          	$error_msg = __CLASS__.'::'.__FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
			log::add('migoThermostat', 'debug',$error_msg);
        }
      	$Unsubscribe_status = (isset($Unsubscribe_naWebhook['status'])) ? $Unsubscribe_naWebhook['status'] : "Nok";
        log::add('migoThermostat', 'debug', 'Unsubscribe Webhook '.$Unsubscribe_status);
      	
      	
      	return $Unsubscribe_status;
    }
////////*****************************************////////
	public static function subscribeWebhook() {
        $ext_url = network::getNetworkAccess('external');
      	$push_url = $ext_url.'/plugins/migoThermostat/core/whook/whook_test.php?apikey=' . jeedom::getApiKey('migoThermostat');
      	
      	if(!$ext_url || !$push_url){
        	log::add('migoThermostat', 'warning', 'No External-Network-Access :: subscribe Webhook aborted '.urlencode($push_url));
          	return;
        }
      	$port = parse_url($push_url, PHP_URL_PORT);
      	if($port != "" &&  $port != 80 &&  $port != 443){
        	log::add('migoThermostat', 'warning', "Attention seuls les ports '80 et 443' sont acceptés:: subscribe Webhook aborted ".$port);
          	return;
        }
      	$app_type = "app_thermostat_".config::byKey('th_type', 'migoThermostat');
      	//$app_type = "app_energy";//"app_thermostat"
      	$params = array('url' => $push_url, 
                        'app_type' => $app_type,
                        'filter' => 'all',
                        'lower_access_level'=> 0
                       );
      
      	$subscribe_status = 'Nok';
      	try {
            $client = self::getWClient('int');
      		$subscribe_naWebhook = $client->api('addwebhook', $params);
         	
        	$subscribe_status = (isset($subscribe_naWebhook['status'])) ? $subscribe_naWebhook['status'] : "Nok";
          	log::add('migoThermostat', 'debug', "subscribe to Webhook '$subscribe_status' ");
          	
        }
        catch (Exception $ex) {
          	$error_msg = __CLASS__.'::'.__FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
			log::add('migoThermostat', 'debug',$error_msg);
        }
      	return $subscribe_status;
      	
    }

	
	
////////*****************************************////////
	public function pppreSave() {//preUpdate,preSave preInsert
        if ($this->getConfiguration('username') == '') {
			throw new Exception(__('Le champs utilisateur ne peut etre vide', __FILE__));
		}
        if ($this->getConfiguration('password') == '') {
			throw new Exception(__('Le champs mot de passe ne peut etre vide', __FILE__));
		}
    }
	/////////////////////////////////////*********************///////////////////////////////////// 
///////*****************************************////////
	public static function getToken($int=NULL) {
      	$user_prefix=config::byKey('th_type', 'migoThermostat');
		$client =  new Migo\Clients\VTThermApiClient(
							array(
								'client_id' => 'na_client_android_'.$user_prefix,
                                'client_secret' => vt::checkClient($user_prefix),
                                'username' => config::byKey('username', 'migoThermostat'),
                                'password' => config::byKey('password', 'migoThermostat'),
                                'scope' => 'read_thermostat write_thermostat read_station',
                                'user_prefix' => $user_prefix,
					));
		try{
			$token = $client->getAccessTokenFromPassword(config::byKey('username', 'migoThermostat'),config::byKey('password', 'migoThermostat'));
          	$return=array('access_token' => $token['access_token']);
          	log::add('migoThermostat', 'debug', __FUNCTION__ ." access_token: " .$token['access_token']."");
			
		}catch (Exception $ex) {//catch(migoThermostatApi\Exceptions\NAClientException $ex){
			$error_msg = __CLASS__.'::'.__FUNCTION__." Erreur lors de la récupération du token" .$ex->getCode()." : ". $ex->getMessage();
          	log::add('migoThermostat', 'debug',$error_msg);
          	throw new Exception($error_msg);
        	
		}	
		return $token;
		
	}
//////// ***************************************** ////////
	public static function getWClient($int=NULL, $forced = false) {
      	$arToken = migoThermostat_W::getlogin($forced);
      	$user_prefix = config::byKey('th_type', 'migoThermostat');
      	if(isset($arToken['expires_at']) && $arToken['expires_at'] > time() ){
          	$store_token = $arToken['access_token'];//."l"
        }
        else{
          	$arToken = migoThermostat_W::getlogin(true);
          	$store_token = isset($arToken['access_token']) ? $arToken['access_token'] : false;
        }
        if (self::$_client === null){
          	log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' w_token : '.$store_token);
      		$credential =[
              			'client_id' => 'na_client_android_'.$user_prefix,
						'client_secret' => vt::checkClient($user_prefix),
						'username' => config::byKey('username', 'migoThermostat'),
						'password' => config::byKey('password', 'migoThermostat'),
						'scope' => 'read_thermostat write_thermostat read_station',
              			'user_prefix' => $user_prefix,
						'func_cb' => 'funccb',
              			'object_cb' => 'migoThermostat',
            ];
          	if($store_token) $credential['access_token'] = $store_token;
          	self::$_client = new Migo\Clients\VTThermApiClient($credential);
		}
     	try {
			$token = self::$_client->getAccessToken();
          	if($token['access_token'] != $store_token ){
          		log::add('migoThermostat', 'debug', __FUNCTION__ .' api tokens: '.$token['access_token']);
            }
		}
		catch (Exception $ex) {
			$error_msg = $ex->getMessage();
			throw new Exception($error_msg,__FILE__);
        }
      
      	if(!isset($token['access_token'])){
			log::add('migoThermostat', 'debug', __FUNCTION__ .' Echec Obtention tokens: '.$token);
		}
      	
      	return self::$_client;
	}
  	/////////////////////////////////////*********************/////////////////////////////////////		
	public static function funccb($arToken) {
      	//log::add('migoThermostat', 'debug', __FUNCTION__ ." arToken: ".json_encode($arToken));
      	if(!is_array($arToken)){
          	$arToken = self::getToken();
       	}elseif(isset($arToken['access_token'])){
            $arToken['token_date'] = time();
            $arToken['expires_at'] = (time() + 10800 - 200);
            //log::add('migoThermostat', 'debug', __FUNCTION__ ." arToken: ".json_encode($arToken));
          	cache::set('migoThermostat_loginFail', 0);
            cache::set('migoThermostat_web', $arToken);
        }
      	
    }
/////////////////////////////////////*********************/////////////////////////////////////		
	public static function getClient($int=null, $forced = false, $user_prefix=null){
        if($user_prefix==null){
			$user_prefix=config::byKey('th_type', 'migoThermostat');
		}
		$arToken = cache::bykey('migoThermostat_web')->getValue([]);
		$store_token=false;
      	if(!$forced && isset($arToken['expires_at']) && $arToken['expires_at'] > time() ){
          	$store_token = $arToken['access_token'];//."l"
          	//log::add('migoThermostat', 'debug', __FUNCTION__ ." store_token: ".$store_token." -- login_ar: ". json_encode($arToken));
        }
        if (self::$_client === null){
          	$credential =[
              			'client_id' => 'na_client_android_'.$user_prefix,
						'client_secret' => vt::checkClient($user_prefix),
						'username' => config::byKey('username', 'migoThermostat'),//."m",
						'password' => config::byKey('password', 'migoThermostat'),
						'scope' => 'read_thermostat write_thermostat read_station',
              			'user_prefix' => $user_prefix,
						'func_cb' => 'funccb',
              			'object_cb' => 'migoThermostat',
            ];
          	if($store_token) $credential['access_token'] = $store_token;
          	self::$_client = new Migo\Clients\VTThermApiClient($credential);
            if(!$store_token || $forced){
                try {	
                    $token = self::$_client->getAccessToken();
                  	log::add('migoThermostat', 'debug', __FUNCTION__ ." Api access_token=" .$token['access_token']."");
                } catch (Exception $ex){
                    $error_msg = __FUNCTION__ ." Erreur d'authentification : " . $ex->getMessage();
                    if(strstr($ex, 'invalid_grant')){
                         $NbLoginFail = cache::bykey('migoThermostat_loginFail')->getValue(0)+1;
                         cache::set('migoThermostat_loginFail', $NbLoginFail);
                         log::add('migoThermostat', 'warning', "loginFail : ". $NbLoginFail);
                    }
                    throw new Exception(__($error_msg, __FILE__));
                }
        	}
		}
      	return self::$_client;
	}
	
/////////////////////////////////////*********************///////////////////////////////////// 	
    public static function connectMigo($from, $update = false) {
		log::add('migoThermostat', 'debug',  __FUNCTION__ .' Start... ');
      	cache::set('migoThermostat','');
		$client = self::getClient('null', true);
		//$devicelist = self::$_data;
      	cache::set('migoThermostat_loginFail', 0);
                         
      	$devicelist = $client->getVtData();
      	if(count($devicelist['devices']) === 0){
			log::add('migoThermostat', 'debug', "Vous n'avez aucun thermostat associé à ce compte");
		}
		foreach ($devicelist['devices'] as $thermostat) {
			if ($thermostat['type']=="NAVaillant"){
            	$deviceid=$thermostat['_id'];
				$moduleid=$thermostat['modules'][0]['_id'];
				$firmdevice=$thermostat['firmware'];
				$firmmodule=$thermostat['modules'][0]['firmware'];
				$emf=($thermostat['modules'][0]['ebus_status']['emf_avail']=true ? 'Compatible' : 'Incompatible');
                $durationsp=$thermostat['setpoint_default_duration'];
				$module_name=$thermostat['station_name'];
				$device_type = $thermostat['type'];
				$module_type = $thermostat['modules'][0]['type'];
				$boilersn = $thermostat['boiler_oem_serial']; 
				$thermostatsn = $thermostat['oem_serial'];
					
				$multiId = $deviceid . '|' . $moduleid;
				$vtplugid=$deviceid . '|' . $deviceid;
				$plug_eqLogic = migoThermostat::byLogicalId($vtplugid, 'migoThermostat');
				if (config::byKey('advancedctrl', 'migoThermostat')==1) {	
					if (!is_object($plug_eqLogic) || $plug_eqLogic->getLogicalId() != $vtplugid) {//
						$plug_eqLogic = new migoThermostat();
						$plug_eqLogic->setIsEnable(1);
						$plug_eqLogic->setIsVisible(1);
								
						$plug_eqLogic->setLogicalId($vtplugid);
						$plug_eqLogic->setCategory('heating', 1);
						$plug_eqLogic->setName('Plug-'.$module_name);
						$plug_eqLogic->setEqType_name('migoThermostat');
						$plug_eqLogic->setConfiguration('devicefirm', $firmdevice);
						$plug_eqLogic->setConfiguration('th_type', 'VtPlug');
						$plug_eqLogic->setConfiguration('type', 'VtPlug');
						//$plug_eqLogic->setStatus('numberTryWithoutSuccess', 0);
                        $plug_eqLogic->save();
					}
				}
					
				$eqLogic = migoThermostat::byLogicalId($multiId, 'migoThermostat');
				$newEq = false;
				if (!is_object($eqLogic)) {
					log::add('migoThermostat', 'debug',  __FUNCTION__ .' Création du thermostat');
					$newEq = true;
                    $eqLogic = new self();
                  	$eqLogic->setLogicalId($multiId);
                    $eqLogic->setName($module_name);
                    $eqLogic->setCategory('heating', 1);
					$eqLogic->setEqType_name('migoThermostat');
                  	$eqLogic->setConfiguration('moduletype',$module_type);
					$eqLogic->setConfiguration('emf', $emf);
                    $eqLogic->setConfiguration('boilersn', $boilersn);
                    $eqLogic->setConfiguration('thermostatsn', $thermostatsn);
					$eqLogic->setConfiguration('battery_type', '3x1.5V AAA');
					$eqLogic->setConfiguration('LogicalMac', $multiId);
                  	$eqLogic->setConfiguration('eqtuile', 'default');
					if (isset($thermostat['dhw'])){
						$ecsmin=$thermostat['dhw_min'];
						$ecsmax=$thermostat['dhw_max'];
						$eqLogic->setConfiguration('dhw_min', $ecsmin);
						$eqLogic->setConfiguration('dhw_max', $ecsmax);
					}
					$eqLogic->setIsVisible(1);
					$eqLogic->setIsEnable(1);
                  
					log::add('migoThermostat', 'debug',  __FUNCTION__ .' New Thermostat: '.$module_name);
                }
              	$Homeglobal = $client->_Homefacility();
              	//log::add('migoThermostat', 'debug',  __FUNCTION__ .' Homeglobal: '.json_encode($Homeglobal));
              	unset($Homeglobal['apiHome']);
                /*$eq_room_multiId = null;
                foreach($Homeglobal as $homeId=>$home) {//array multi scope
                  	//log::add('migoThermostat', 'debug',  __FUNCTION__ .' home: '.json_encode($home));
              	
                  	$syncTime = $home['ASyncTime'];
					unset($home['ASyncTime']);
					foreach($home as $supEqId=>$eqdata) {
                      	if(!is_array($eqdata) || empty($eqdata)){
                            log::add('migoThermostat', 'warning',  __FUNCTION__ ." Invalid Data : " .$supEqId);   
                            continue;
                        }
                        list($roomId, $homeId) = explode('|', $supEqId);
                        if( !isset($roomId) || !isset($homeId) || $roomId=="Home"){
                            //log::add('migoThermostat', 'warning', "Invalid roomdata : " .$supEqId."=>".json_encode($eqdata));   
                            continue;
                        }
                        $eq_room_multiId = $supEqId;
                    	log::add('migoThermostat', 'warning',  __FUNCTION__ ." eq_room_multiId : $eq_room_multiId");
                    }
                } */     
                      
                if( $newEq == true || $update == true){
                    //$eqLogic->setConfiguration('room_multiId', $eq_room_multiId);
					$eqLogic->setConfiguration('maxdefault', $durationsp);
					$eqLogic->setConfiguration('devicefirm', $firmdevice);
					$eqLogic->setConfiguration('modulefirm', $firmmodule);
					$eqLogic->setConfiguration('th_type', config::byKey('th_type', 'migoThermostat'));
					$eqLogic->setConfiguration('type', 'VtTherm');
					//$eqLogic->setStatus('numberTryWithoutSuccess', 0);
                    $eqLogic->setConfiguration('dash', 'VtTherm'.$jeeVersion);
					
					
                    
				}else{
					$eqLogic->setConfiguration('devicefirm', $firmdevice);
					$eqLogic->setConfiguration('modulefirm', $firmmodule);
					if(config::byKey('displayDesktopPanel', 'migoThermostat', 0)){
                    	$eqLogic->setConfiguration('hasPanel', TRUE);
                    }
				}
                $eqLogic->save();
				$eqLogic->syncFromWeb($multiId);
				//self::makeCmd($eqLogic);	
			}else {
				log::add('migoThermostat', 'warning', __FUNCTION__ .' No compatible device found');
			}
		}
	}
	
////////////////////////////////*********************************************////////////////////////////////////////////////
	public function syncFromWeb($_multiId = null, $Int = null, $cronPhase = null) {
		$deviceid = null;
        if($_multiId != null){
			list($deviceid, $moduleid) = explode('|', $_multiId);
      	}
      	$client = self::getClient('null');
          	
      	try {
			$thermdata = $client->getVtData($deviceid);
          	self::writedataStat(json_encode($thermdata, JSON_PRETTY_PRINT), 'thermdata.json');
			log::add('migoThermostat', 'debug',  __FUNCTION__ .' thermdata '.json_encode($thermdata));
        }catch (Exception $ex) {
			$error_msg = "Erreur :  " .$ex->getCode()." - ". $ex->getMessage() . " sur : '".$deviceid."'";
			log::add('migoThermostat', 'warning', '	'.__FUNCTION__ .' '.$error_msg);
          	throw new Exception(__(__FUNCTION__ .' '.$error_msg, __FILE__));
        }
      	$devicesData = $thermdata['devices'];
      	
		foreach ($devicesData as $thermostat) {
			$modename = '';
			$consigne = '';
			$deviceid=$thermostat['_id'];
			$moduleid=$thermostat['modules'][0]['_id'];
			$multiId = $deviceid . '|' . $moduleid;
          	$name = $thermostat['station_name'];
          	if ($multiId != $_multiId) {
              	continue;
			}
          	$eqLogic = eqLogic::byLogicalId($multiId,'migoThermostat');
			if (!is_object($eqLogic)) {
				continue;
			}
			$moduleInfos = $thermostat['modules'][0];
          	////////// Info general	
			$batterie=$moduleInfos['battery_percent'];
			$rfstatus=$moduleInfos['rf_status'];
				$eqLogic->setStatus('rfstatus', $rfstatus);
			$wifistatus=$thermostat['wifi_status'];
				$eqLogic->setStatus('wifistatus', $wifistatus);
			$tsyncext=date('Y-m-d H:i:s', $thermostat['outdoor_temperature']['ti']);
			$timesync=isset($thermostat['last_sync_asked']) ? date('Y-m-d H:i:s', $thermostat['last_sync_asked']):"";
			$firmdevice=$thermostat['firmware'];
				$eqLogic->setConfiguration('devicefirm', $firmdevice);
			$firmmodule=$moduleInfos['firmware'];
				$eqLogic->setConfiguration('modulefirm', $firmmodule);
			$durationsp=$thermostat['setpoint_default_duration'];
			
			$eqLogic->setStatus('lastPlugSeen', date('Y-m-d H:i:s', $thermostat['last_plug_seen']));
          	//log::add('migoThermostat', 'debug', __FUNCTION__ .' lastPlugSeen: '.date('Y-m-d H:i:s', $thermostat['last_plug_seen']));
			$eqLogic->setStatus('lastThermSeen', date('Y-m-d H:i:s', $moduleInfos['last_therm_seen']));//lastThermSeen
			///////////////////	getVtMesure ////////////////////
			$flowsetpoint="LAST";
			$mesuresNow = migoThermostatGraph::getNowMeasures($deviceid, $moduleid);
			log::add('migoThermostat', 'debug', __FUNCTION__ .' mesuresNow: '.json_encode($mesuresNow));
			if(!empty($mesuresNow)){
                $mesured_tempin =  $mesuresNow['Temperature'] ;
                $mesured_sp_temp = $mesuresNow['Sp_Temperature'] ;
                $flowsetpoint = $mesuresNow['flow_setpoint'];
			}
          	
           	$error ='';		
			$error .= $ebus_error=($thermostat['ebus_status']['ebus_error']!=false) ? ' Erreur ebus avec la chaudière' : null;
			$error .= $th_ebus_error=($thermostat['ebus_error']!=false) ? ' Erreur de communication ebus avec la chaudière' : null;
			$error .= $boiler_error=($thermostat['ebus_status']['boiler_error']!=false) ? ' Chaudière en erreur' : null;
			$error .= $refill_water=($thermostat['ebus_status']['refill_water']!=false) ? ' Chaudière; Pression insufisante' : null;
			$error .= $maintenance_status=($thermostat['ebus_status']['maintenance_status']!=false) ? ' Chaudière; maintenance necessaire' : null;
			if($ebus_error || $boiler_error || $refill_water || $maintenance_status){
               	log::add('migoThermostat', 'error', '	'.$eqLogic->getName().' Anomalie détectée: '.$error);       
			}elseif(!empty($thermostat['boiler_error'])){
              	$msg = ' Anomalie ebus détectée: '.json_encode($thermostat['boiler_error']);
              	log::add('migoThermostat', 'error', '	'.$eqLogic->getName().$msg);       
			}
          
         ////////////// Boiler Mode
			$heatermode=$thermostat['system_mode'];// heatermode : winter/summer/frostgaurd
			if ($heatermode == "winter") {///$planning
				$boilermode="Hiver";
				$heatermodeindex=1;
			}
			elseif ($heatermode == "summer") {///$planning
				$boilermode="Eté";
				$heatermodeindex=2;
			}
			elseif ($heatermode == "frostguard") {///$planning
				$boilermode="Anti-gel";
				$heatermodeindex=3;
			}
				
				
		///////////// Température 
		
			$temperature_thermostat = null;
			$temperature_thermostat =  number_format(round( $moduleInfos['measured']['temperature'], 1), 1, '.', ',');
			if (isset($moduleInfos['reachable'])){
              	$reachable = $moduleInfos['reachable'];
              	if (!$reachable){
                	log::add('migoThermostat','warning',' Le thermostat semble injoignable !');
            	}
            }
          	
          
          	if (isset($moduleInfos['boiler_status'])){
              	$boiler_status = $moduleInfos['boiler_status'];
            }
          	
          	if($temperature_thermostat == null && isset($mesured_tempin)){
				$temperature_thermostat =  number_format(round($mesured_tempin, 1), 1, '.', ',');
			}
		///////////// Consigne Température
			$consigne = null;
			$consigne = number_format(round( $moduleInfos['measured']['est_setpoint_temp'], 1), 1, '.', ',');
			if($moduleInfos['measured']['est_setpoint_temp'] == null){
				$consigne =  number_format(round($mesured_sp_temp, 1), 1, '.', ',');
			}
        ///////////// Température exterieure
          	$outbasetemp = "LAST";
			if($cronPhase){//$cronPhase
              	//$outbasetemp=number_format(round($thermostat['outdoor_temperature']['te'], 1), 1, '.', ',');
          		try{
					$outdoortemp= $client->getoutdoortemperature($deviceid);
					$outbasetemp = number_format(round($outdoortemp, 1), 1, '.', ',');
				}catch (Exception $ex) {
                    $error_msg = __FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
                    log::add('migoThermostat', 'warning', '  ******'.__FUNCTION__ .' '.$error_msg);
				}
              	log::add('migoThermostat','debug',"outbasetemp($deviceid): ". $outbasetemp);
            }
		//////////anticipation chauffage
			$anticipation=$moduleInfos['anticipating'];////me
			$anticipation=($anticipation != FALSE) ? "TRUE" : "FALSE";//1 : 0;
		///////// thermostat sync statut
			//$syncstate = isset($thermostat['syncing']) ? (($thermostat['syncing'] != 0) ? "TRUE" : "FALSE") : "";	
		///////////// Température ECS
			if (isset($thermostat['dhw'])){
				$ecstemp=$thermostat['dhw'];
			}else {$ecstemp='0';}
			///////////// Ecs Boost state
			$ecsBoostState=$thermostat['setpoint_hwb']['setpoint_activate'];////me
			$ecsBoostState=($ecsBoostState != 0) ? 'TRUE' : 'FALSE';
			$actualdate=date('d/m/Y');
			if (isset($thermostat['setpoint_hwb']['setpoint_endtime'])){
				if ($actualdate == $ecsBoostEndtime = date('d/m/Y',$thermostat['setpoint_hwb']['setpoint_endtime'])) {
					$ecsBoostEndtime =date('H:i',$thermostat['setpoint_hwb']['setpoint_endtime']);
				} else {
					$ecsBoostEndtime =date('d/m H:i',$thermostat['setpoint_hwb']['setpoint_endtime']);
				}
			}
			///////////// Ecs anticipating
			$ecsanticip = $thermostat['hot_water_anticipating'];;////me
			$ecsanticip = ($ecsanticip != 0) ? "TRUE" : "FALSE";
		
		///////// chaudiere-state   chaudiere On/OFF pas d'info direcet
			$heatingstate='';
			if ($boiler_status || $anticipation == "TRUE" || $flowsetpoint > 1){
                $heatingstate = "TRUE";
                $heatstatus = 1;
			} else {
                $heatingstate = "FALSE";
                $heatstatus = 0;
			}
			 
			
        ////////// Liste planning et Planning en cours
			$calendar='';
			
			$proglist=$moduleInfos['therm_program_list'];
			$calendar = self::getCalendar($proglist);
			log::add('migoThermostat', 'debug',  __FUNCTION__ .' calendar '.json_encode($calendar));					
			$nowplanning = $calendar['nowplanning'];
			$nowplanid = $calendar['nowplanid'];
			$listplanning = $calendar['listplanning'];
			$listprofil = $calendar['listprofil'];
			$nowprofil = $calendar['nowprofil'];
			$nowprofil_temp = $calendar['nowprofil_temp'];
			$nextprofil = $calendar['nextprofil'];
			$nextprofil_temp = $calendar['nextprofil_temp'];
			$profil_endtime = $calendar['profil_endtime'];
          	$profil_hwb = $calendar['profil_hwb'];
          //$ecsBoostState=($ecsBoostState != 0) ? 'TRUE' : 'FALSE';
			//log::add('migoThermostat', 'debug',  '********'.__FUNCTION__ ." profil_hwb: ".$profil_hwb);
          	if ($profil_hwb == 1 || $ecsBoostState == "TRUE") {// 
             	$ecsState = true;
              	//log::add('migoThermostat', 'debug',  '********'.__FUNCTION__ ." ecsState: ".$ecsState);
            }else{
              	$ecsState = false;
            }
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////				Fin Profiles							
			//////////// Mode away
          	$awaystate = "FALSE";
          	if(isset($moduleInfos['setpoint_away']['setpoint_activate']) 
              && $moduleInfos['setpoint_away']['setpoint_activate'] == true){
              	if (isset($moduleInfos['setpoint_away']['setpoint_endtime'])){
                  	$away_spendtime = $moduleInfos['setpoint_away']['setpoint_endtime'];
                  	if ($away_spendtime == 0) {
						$awaystate= "TRUE";
                      	$setpointmode_endtime = $awayendtime = "Nouvel Ordre";
					} elseif ($away_spendtime < time()) {
						log::add('migoThermostat', 'debug',  __FUNCTION__ .' away in past ');
					} elseif ($actualdate == date('d/m/Y',$away_spendtime)) {
						$setpointmode_endtime = $awayendtime = date('H:i',$away_spendtime);
                      	$awaystate= "TRUE";
                      	//$mode ='away';
                      	//$modename='Away'
					} else {
						$setpointmode_endtime = $awayendtime = date('d/m H:i',$away_spendtime);
                      	$awaystate= "TRUE";
                      	//$mode ='away';
                      	//$modename='Away';
					}
				}
			}
          
          	//////////// Mode manual
          	$manualstate = "FALSE";
          	if(isset($moduleInfos['setpoint_manual']['setpoint_activate']) 
              && $moduleInfos['setpoint_manual']['setpoint_activate'] != 0){
              	if (isset($moduleInfos['setpoint_manual']['setpoint_endtime'])){
                  	$manual_spendtime=$moduleInfos['setpoint_manual']['setpoint_endtime'];
                  	if ($manual_spendtime == 0 ) {
                      	$manualstate= "TRUE";
                      	$setpointmode_endtime = "Nouvel Ordre";
						//log::add('migoThermostat', 'debug',  __FUNCTION__ .' manual Nouvel Ordre ');
					} elseif ($manual_spendtime > 0 && $manual_spendtime < time()) {
						//log::add('migoThermostat', 'debug',  __FUNCTION__ .' manual in past 2');
					} elseif ($actualdate == date('d/m/Y',$manual_spendtime)) {
						$setpointmode_endtime = date('H:i',$manual_spendtime);
                      	$manualstate= "TRUE";
                    } else {
						$setpointmode_endtime = date('d/m H:i',$manual_spendtime);
                      	$manualstate= "TRUE";
                    }
				}
			}
          	if ($awaystate=="TRUE" && $manualstate=="FALSE") {
				$mode ='away';
			}elseif ($manualstate=="TRUE" && $awaystate=="FALSE") {
				$mode ='manual';
			}elseif ($awaystate=="TRUE" && $manualstate=="TRUE") {
				$mode ='manaway';
			}elseif  ($heatermode == "winter" && !empty($nowplanning)) {///$planning
				$mode ='program';
			}elseif  ($heatermode=="summer") {///$planning
				$mode ='summer';
			}else $mode ='off';
			
			log::add('migoThermostat', 'debug',  __FUNCTION__ .' mode '.$mode);
			/////////////////////////////////
			if ($mode =='program') {
				if ($profil_endtime!=null){
					//$setpointmode_endtime=$profil_endtime;
					if ($actualdate <= date('d/m/Y', $profil_endtime-43200) || $actualdate == date('d/m/Y', $profil_endtime) ) {
						$setpointmode_endtime=date('H:i',$profil_endtime);
					} else {
						$setpointmode_endtime=date('d/m H:i',$profil_endtime);
					}
				}
				$modename = "Programme";
			} 
		///////////	($listmode['type'] == 3)?????
			elseif ($mode =='summer') {//'hg'
				$modename= "Summer";
				$consigne=$moduleInfos['measured']['est_setpoint_temp'];
			}
		///////////	($listmode['type'] == 3)?????
			elseif ($mode =='off') {//'hg'
				$modename= "OFF";
			}
			else {
				$modename = $mode.'0';
			}
			if ($modename == '') {
				$modename = $mode.'1';
			}
			if ($consigne == '') {
				$consigne = 8;
			}
		
	
			///////////// Consigne Température
			$inuse='hc_'.$thermostat['house_model']['in_use'];
			$hcperso=array(
                          'courbe_perso'=>($thermostat['house_model']['hc_perso']['slope']/10),
                          'hwbmin_perso'=>$thermostat['house_model']['hc_perso']['min_flow_set_point'],
                          'hwbmax_perso'=>$thermostat['house_model']['hc_perso']['max_flow_set_point'],
                          'tempshift_perso'=>$thermostat['house_model']['hc_perso']['temp_shift'],
                          'baseexternaltemp_perso'=>$thermostat['house_model']['hc_perso']['base_external_temp'],
                          'maxexttemp_perso'=>$thermostat['house_model']['hc_perso']['max_ext_temp'],
			);
			
			$hcinuse = array(
                          'courbe'=>($thermostat['house_model'][$inuse]['slope']/10),
                          'hwbmin'=>$thermostat['house_model'][$inuse]['min_flow_set_point'],
                          'hwbmax'=>$thermostat['house_model'][$inuse]['max_flow_set_point'],
                          'tempshift'=>$thermostat['house_model'][$inuse]['temp_shift'],
                          'baseexternaltemp'=>$thermostat['house_model'][$inuse]['base_external_temp'],
                          'maxexttemp'=>$thermostat['house_model'][$inuse]['max_ext_temp'],
			);
			
			//if($setpointmode_endtime != 'Nouvel Ordre'){
			if($profil_endtime != 'Nouvel Ordre'){
				$durationmode=round( ($profil_endtime-time()) / 60 );
              	//log::add('migoThermostat','debug',' **** profil_endtime '.$durationmode);
			}else{
				$durationmode='Unlimited';
			}
			
			$offset=$moduleInfos['measure_offset']['a'];
			$algotype=$thermostat['house_model']['algo_type'];
			if($algotype=='pid_algo'){
				$curve_inuse = $hcinuse['courbe'];
				$curve_set = $hcperso['courbe_perso'];
				$curve = $curve_inuse.'|'.$curve_set;
				$hwbmin = $hcinuse['hwbmin'];
				$hwbmax = $hcinuse['hwbmax'];
				$tempshift = $hcinuse['tempshift'];
				$baseexternaltemp = $hcinuse['baseexternaltemp'];
				$maxexttemp = $hcinuse['maxexttemp'];
			}
			
			
		//////////////////////////////////////////////////
			foreach ($eqLogic->getCmd('info') as $cmd) {
				$value=null;
				switch ($cmd->getLogicalId()) {
					///////////////////////////////////// outbasetemp mesuronoff 
					case 'flowsetpoint': $value = $flowsetpoint; break;
					case 'boileron_today': $value = isset($duree_on_today) ? $duree_on_today : "LAST"; break;
					case 'boileron_yest': $value = isset($duree_on_yesterday) ? $duree_on_yesterday : "LAST"; break;
					case 'gazhier': $value = isset($ConsoGaz_Hier) ? $ConsoGaz_Hier : "LAST"; break;
					case 'gazmois': $value = isset($ConsoGaz_Mois) ? $ConsoGaz_Mois: "LAST"; break;
					case 'elechier': $value = isset($Consoelec_Hier) ? $Consoelec_Hier: "LAST"; break;
					case 'elecmois': $value = isset($Consoelec_Mois) ? $Consoelec_Mois: "LAST"; break;
					case 'hwbmin': $value=$hwbmin; break;
					case 'hwbmax': $value=$hwbmax; break;
					case 'tempshift': $value=$tempshift; break;
					case 'baseexternaltemp': $value=$baseexternaltemp; break;
					case 'maxexttemp': $value=$maxexttemp; break;
						
					//case 'awayendtime': $value=$awayendtime; break;
					case 'awayendtime': $value = (isset($awayendtime) ? $awayendtime: false); break;
						
					//case 'ecsBoostEndtime': $value=$ecsBoostEndtime; break;
					case 'ecsBoostEndtime': $value = (isset($ecsBoostEndtime) ? $ecsBoostEndtime: false); break;
					case 'outbasetemp': $value = $outbasetemp ? $outbasetemp : "LAST"; break;
					case 'temperature': $value = $temperature_thermostat; break;
					case 'consigne': $value=$consigne; break;
					case 'manualstate': $value=$manualstate; break;
					case 'awaystate': $value=$awaystate; break;
					case 'ecsBoostState': $value=$ecsBoostState; break;
					case 'ecsState': $value=$ecsState; break;
					case 'ecstemp': $value=$ecstemp; break;
					case 'ecsmin': $value=$ecsmin; break;
					case 'ecsmax': $value=$ecsmax; break;
					case 'curve': $value=$curve; break;
					case 'offset': $value=$offset; break;
					case 'boilermode': $value=$boilermode; break;
					
					case 'heatermode': $value=$heatermodeindex; break;
					case 'mode': $value=$modename; break;	
					case 'durationmode': $value=$durationmode; break;					
					case 'modetech': $value=$mode; break;
					case 'wifistatus': $value=$wifistatus; break;
					case 'rfstatus': $value=$rfstatus; break;
					case 'profil': $value=$nowprofil; break;
					case 'nextprofil': $value = $nextprofil.':'. $nextprofil_temp ;break;
					case 'planning': $value=$nowplanning;break;
					case 'planid': $value=$nowplanid; break;
					case 'listplanning': 
						$value=$listplanning;
						$cmd_planningset = $eqLogic->getCmd(null, 'planningset');
						if (is_object($cmd_planningset)) {
							$cmd_planningset->setConfiguration('listValue',  $listplanning);
							$cmd_planningset->save();
							$cmd_planningset->refresh();
						}
					//substr($listplanning, 0, -1); 
						break;
					case 'listprofil': $value=$listprofil;//substr($listprofil, 0, -1); break;	
					case 'heatstatus': $value = $heatstatus; 
					//log::add('migoThermostat', 'debug', '	heatstatus: '.$heatstatus);
            			break;
						
					case 'anticipation': $value=$anticipation; break;
					case 'ecsanticip': $value=$ecsanticip; break;
					case 'endsetpoint': //$value= $setpointmode_endtime; break;
					if ($mode == 'away') {
						$value= $awayendtime;
					}elseif ($mode == 'manual' || $mode == 'manaway' || $mode == 'program') {
						$value = $setpointmode_endtime;//$awayendtime;$setpointmode_endtime
					}else{
						$value='';
					}
						break;
					case 'batterie': 
						$value=$batterie; 
						$eqLogic->batteryStatus($batterie);
						break;
					case 'statusname'://$manualendtime,$awayendtime
						if ($mode == 'manual') {
							$value= 'Jusqu\'à ' .  $setpointmode_endtime;
						} 
						if ($mode == 'away') {
							$value= 'Jusqu\'à ' . $awayendtime;
						} else if ($mode == 'manaway') {
							$value='Manual-> ' . $setpointmode_endtime. ' Away-> ' .$awayendtime;
						} else if ($mode == 'program') {////
							$value= $nowprofil . ' -> ' . $setpointmode_endtime . ' ' .$nextprofil;
						} else if ($mode == 'summer') {
							$value='Chaudière Mode Eté';
						} else if ($mode == 'frostguard') {
							$value= 'Chaudière Mode HG' ;
						} else if ($mode == 'off') {
							$value='Antigel';
						} else {
							$value='1 Jusqu\'à ' . $setpointmode_endtime;
						}
						break;
                //end swich    
				}
				//$cmd->event($value);
				if($value !== "LAST"){
                  	//log::add('migoThermostat','debug','set: '.$cmd->getName().' to: '. $value);
              		$eqLogic->checkAndUpdateCmd($cmd, $value);
                }
              	else{
                  	//log::add('migoThermostat','warning',' no value : '.$cmd->getName().' to: '. $value);
                }
				$cmdi=[];
                $cmdi[$cmd->getLogicalId()] = $value;
				
			}
			$eqLogic->refreshWidget();
			log::add('migoThermostat','debug','fin sync ');
			return $cmdi;
		}
    // fin foreach
    }
//////////////////////////set Manual mode	
	public function getCalendar($proglist) {
		$nowplanning='';
		$nowplanid='';
		$nowprofil ='Aucun';
		$nextprofil ='Aucun';
		$setpointmode_endtime ='Nouvel Ordre';
		$listplanning='';
		$listprofil='';
	///////// Liste des plannings et planning en cours
		foreach ($proglist as $keyplan => $plan) {
			//$status=(isset($plan['selected'])) ? "TRUE" : "FALSE";//////<<? "YES" : "NO";
			if (isset($plan['selected']) && $plan['selected'] == TRUE){//////<<?
				//Planning actif
				$keyGoodplan=$keyplan;
				$nowplanning=$plan['name'];
				$nowplanid=$plan['program_id'];
			}
			$listplanning=$listplanning . $plan['program_id'] . '|' . $plan['name'] . ';';
		}
		$nowoffset=floor( (time()-date(strtotime('Monday this week')) )/60);//
		$nbtime=count($proglist[$keyGoodplan]["timetable"]);
		$actifplan=$proglist[$keyGoodplan];
      	
	///////// Profil actif et profil suivant
		foreach ($actifplan["timetable"] as $key => $time) {
			if ($time["m_offset"] >= $nowoffset){
				//Pendant la semaine
				$nextgoodkey = $key;
				$nextprofil_id = $time["id"];
              	$nowprofil_id = ($nextgoodkey > 0) ? $actifplan["timetable"][$nextgoodkey-1]["id"] : $actifplan["timetable"][0]["id"];
				$profil_offset = $time["m_offset"];
              	break;
			} elseif ($key == ($nbtime-1)){
				//Derniere plage de la semaine
              	$nowgoodkey = $nbtime-1;
				$nowprofil_id = $actifplan["timetable"][$nowgoodkey]["id"];
				if($actifplan["timetable"][0]["id"]==$nowprofil_id){
					$nextprofil_id= isset($actifplan["timetable"][1]) ? $actifplan["timetable"][1]["id"]  : null;
					$profil_offset = isset($nextprofil_id) ? $actifplan["timetable"][1]["m_offset"]+7*24*60 : null; ;
				}else{
					$nextprofil_id= $actifplan["timetable"][0]["id"];
					$profil_offset = $actifplan["timetable"][0]["m_offset"]+7*24*60;
				}
			}
		}
		if ($profil_offset != 0) {
			$firstday=date(strtotime('Monday this week'));
		}else{//semaine prochaine
			$firstday=date(strtotime('Monday this week +6 days'));
		}
									
		$profil_endtime = date($firstday + $profil_offset*60);
		log::add('migoThermostat',__FUNCTION__ .' debug','profil_endtime: '.$profil_endtime);
      	/*if ($profil_endtime == '') {
				$profil_endtime='00:00';
			}
			*/	
	///////// Liste des profils/profil actif-suivant/temp
		foreach ($actifplan["zones"] as $key => $zone) {
			if (!isset($zone['name'])) {	
				if ($zone['type'] == 0) {
					$profilname = 'Home'.';'.$zone['temp'];
				}elseif ($zone['type'] == 1) {
					$profilname = 'Nuit'.';'.$zone['temp'];
				}elseif ($zone['type'] == 3) {
					$profilname = 'HG'.';'.$zone['temp'];
				}elseif ($zone['type'] == 5) {
					$profilname = 'Absent'.';'.$zone['temp'];
				}else{
					$profilname = 'Profile T° '.$zone['temp'].';'.$zone['temp'];
				}
              	
			}else{
				$profilname = $zone['name'].';'.$zone['temp'];
			}
          	
            $listprofil=$listprofil.$profilname .'|';
						
			///////////////////////
			if ($zone['id'] == $nowprofil_id) {
				list($nowprofil, $nowprofil_temp) = explode(';', $profilname);
              	$profil_hwb=$zone['hw'];  	
			} elseif ($zone['id'] == $nextprofil_id) {
				list($nextprofil, $nextprofil_temp) = explode(';', $profilname);
            }
		}
		$response['nowplanning']=$nowplanning;
		$response['nowplanid']=$nowplanid;
		$response['listplanning']=substr($listplanning, 0, -1);//$listplanning;
		$response['listprofil']=substr($listprofil, 0, -1);//$listprofil;
		$response['nowprofil']=$nowprofil;
		$response['nowprofil_temp']=$nowprofil_temp;
		$response['nextprofil']=$nextprofil;
		$response['nextprofil_temp']=isset($nextprofil_temp) ? $nextprofil_temp : '';
		$response['profil_endtime']=$profil_endtime;
      	$response['profil_hwb']=$profil_hwb;
      	//log::add('migoThermostat','debug',__FUNCTION__ .' **** profil_hwb '.$profil_hwb);
		return $response;
	}

///////////////////////commandes**********////////////////////////
	public function setManual($multiId,$activate, $temperatureset=null, $endtime =null) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
		
		$getboilermode = self::getCmd(null, 'boilermode')->execCmd();//Anti-gel;Hiver;Eté	
			if ($activate=='false'){
				$apicmd = $client->setToManualMode($deviceid, $moduleid, 'false');	 
				//log::add('migoThermostat', 'debug', __FUNCTION__ . " Manual mode diseabled".json_encode($apicmd['status']));
				$actioninfo=" mode diseabled";
			} else{
				
				if ($endtime == null){
					$endtime = time() + ($this->getConfiguration('maxdefault')* 60);
				} 
				$length=date("d-m-Y H:i", $endtime);
				if ($getboilermode == 'Anti-gel'){///1=frostguerd
					$actioninfo=" mode impossible; Boiler mode est: ".$getboilermode;
				}
				else{//1="frostguard"; 2="winter"; 3="summer"
					$apicmd=$client->setToManualMode($deviceid, $moduleid, 'true', $temperatureset, $endtime);
					$actioninfo=" mode activé ". $temperatureset . "° jusqu'au " . $length ;
				}
			}
		
		sleep(2);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug',__FUNCTION__ .' cmd : '.$actioninfo. ' non exécutée '. $apicmd['status']);
		} else{
			$cmdrsp = 'ok';
			log::add('migoThermostat', 'debug',__FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd['status']));
			$this->syncFromWeb($multiId,'int');
		}	
		return $cmdrsp; 
	}

//////////////////////////set away mode
	public function setAway($multiId, $activate, $endtime = null) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
				
		if ($activate=='false'){
			$apicmd = $client->setToAwayMode($deviceid, $moduleid, 'false');	 
			$actioninfo = 'Away mode diseabled';
		} 
		else {
			$apicmd = $client->setToAwayMode($deviceid, $moduleid, 'true', $endtime);
			$actioninfo = 'Away mode activé';
		}
		
		sleep(2);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat','debug',__FUNCTION__ .' cmd : '.$actioninfo. ' non éxécutée '. $apicmd['status']);
		} else{
			$cmdrsp = 'ok';
			log::add('migoThermostat', 'debug', __FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd['status']));
			$this->syncFromWeb($multiId,'int');
		}
		
    }
///////////////////////commandes**********////////////////////////
	public function setProgram($multiId,$action, $endtime = NULL) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
		switch ($action) {
			/*
			case 'away':
				$client->setToAwayMode($deviceid, $moduleid, 'true', $endtime);
			*/	
			case 'program':
				//log::add('migoThermostat', 'debug',"swich action program 828: ");
				$actioninfo="set to program ";
				$apicmd=$client->setToWinter($deviceid, $moduleid);
				$apicmd=$client->setToManualMode($deviceid, $moduleid, 'false');
				$apicmd=$client->setToAwayMode($deviceid, $moduleid, 'false');
				//$client->setToProgramMode($deviceid, $moduleid);
				
			break;
			
						
		}
		sleep(2);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat','debug',__FUNCTION__ .' cmd : '.$actioninfo. ' non éxécutée '. $apicmd['status']);
		} else{
			$cmdrsp = 'ok';
			log::add('migoThermostat', 'debug', __FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd['status']));
			$this->syncFromWeb($multiId,'int');
		}
    }
	//setToFrostGuard/setToSummer/setToWinter	
	
///////////////////////////////////////// switch schedule
	public function changesplanningTherm($multiId, $planningToset) {
		
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
		log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' to : '.$planningToset);
		if(substr($planningToset, 0, 1).strlen($planningToset) == 524){
			$planningid=$planningToset;
			$actioninfo=''.__FUNCTION__ .' 524 Setting planning to : '.$planningid;
		}else {
			$planning_string = self::getCmd(null, 'listplanning')->execCmd();
			$planning_list = explode( ';' , $planning_string);
			
			foreach ($planning_list as $plan) {
				
				$detail_planning = explode( '|' , $plan);
				
				if ($planningToset === $detail_planning[1]) {
					$actioninfo=__FUNCTION__ .' Planning found : '.$planningToset.' to: '.$detail_planning[0];
					$planningid = $detail_planning[0];
					break;
					
				} else {
					$planningid = $planningToset;
					$actioninfo=''.__FUNCTION__ .' Unknown Id or Name ! : '.$planningid;
				}
			}
		}
		$apicmd=$client->changeSchedule($deviceid, $moduleid, $planningid);
		sleep(3);
				
		if($apicmd != "planning changed"){
			$cmdrsp = 'Nok';
			log::add('migoThermostat','debug',__FUNCTION__ .' '.$actioninfo. ' non éxécutée '. json_encode($apicmd) );
		} else{
			$cmdrsp = 'ok';
			log::add('migoThermostat', 'debug', __FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd) );
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp; 
	}
////////////////////set Boiler Mode///////////////////////winter/summer/frostguard
	public function setBoilerMode($multiId, $boilermode) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	log::add('migoThermostat','debug',''.__FUNCTION__ .' to: '.strtolower($boilermode));
		switch (strtolower($boilermode)) {
			case 'winter':
			case '1':
			case 'hiver':
				log::add('migoThermostat','debug',__FUNCTION__ .' to: '.strtolower($boilermode));
				$syssetmode='winter';
				break;
			case 'summer':
			case '2':
			case 'été':
				log::add('migoThermostat','debug',__FUNCTION__ .' to: '.strtolower($boilermode));
				$syssetmode='summer';
				break;
			case 'frostguard':
			case '3':
			case 'hors-gel':
				log::add('migoThermostat','debug',__FUNCTION__ .' to: '.strtolower($boilermode));
				$syssetmode='frostguard';
				break;
			default:
				$syssetmode=$boilermode;
			break;
		}
		$actioninfo='set BoilerMode to: '.$boilermode.'-'.$syssetmode;
		$client = self::getClient('int');
		$apicmd=$client->setMasterMode($deviceid, $moduleid, $syssetmode);
		
		//log::add('migoThermostat', 'debug',"f setBoilerMode l-771".json_encode($rep,true));		
		sleep(2);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat','debug',__FUNCTION__ .' cmd : '.$actioninfo. ' non exécutée '. $apicmd['status']);
		} else{
			$cmdrsp = 'ok';
			log::add('migoThermostat', 'debug', __FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd['status']));
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp; 
	}
///////////////////////////////////////// setTempEcs
	public function setTempEcs($multiId, $temperaturesethw) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
				
		$_hw = array('device_id' => $deviceid,'dhw' => $temperaturesethw);
		$apicmd= $client->api('sethotwatertemperature', 'POST', $_hw);
		log::add('migoThermostat', 'debug',"f setTempEcs l-770 to : " .$temperaturesethw.' '.json_encode($apicmd,true));	
		$actioninfo="set TempEcs to : " .json_encode($_hw,true);
		
		sleep(2);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat','debug',__FUNCTION__ .' cmd : '.$actioninfo. ' non éxécutée '. $apicmd['status']);
		} else{
			log::add('migoThermostat', 'debug',__FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp; 
	}
/////////////////////////////////////////
	public function setBoostEcs($multiId, $activate=null, $setEcsEndtime =null){	
		list($deviceid, $moduleid) = explode('|', $multiId);		
		$client = self::getClient('int');
		log::add('migoThermostat', 'debug',"f setBoostEcs 784: ".$activate."; ".$setEcsEndtime);
		
      	if (!$activate){
			//$test=$thermostat['setpoint_hwb']['setpoint_activate'];
          	$test = self::byLogicalId($multiId, 'migoThermostat')->getCmd(null, "ecsBoostState")->execCmd();
				
			if ($test == 'TRUE'){
				log::add('migoThermostat', 'debug',"action hwboost test_state: . $test");
				$activate=false;
			}
          	else {
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action hwboost test_state ".$test);
				$activate=true;
			}
		}		
		if ($activate == false || strtolower($activate) == 'false'){
			$actioninfo="set BoostEcs desactivated: ";
			$apicmd=$client->setHwbBoost($deviceid, $moduleid, 'false');
		}else {
			$actioninfo="set BoostEcs activated: for ".$setEcsEndtime;
			$apicmd=$client->setHwbBoost($deviceid, $moduleid, 'true', $setEcsEndtime);
		}
		
		sleep(2);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat','debug',__FUNCTION__ .' cmd : '.$actioninfo. ' non éxécutée '. $apicmd['status']);
		} else{
			$cmdrsp = 'ok';
			log::add('migoThermostat', 'debug', __FUNCTION__ .' '.$actioninfo .'--'.json_encode($apicmd['status']));
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp; 
	}
	
/////////////////////////////////////*********************/////////////////////////////////////
	public static function cronDaily($_multiId = null){
      	//if($multiId == null) $multiId = $this->getLogicalId();
      	log::add('migoThermostat', 'debug', __FUNCTION__ .' started *****************');
      	if(self::$_isMaster){
          	$subscribeWebhook = self::subscribeWebhook();
        }
      	$hasDesktopPanel = config::byKey('displayDesktopPanel', 'migoThermostat', 0);
		if($_multiId != null){
			$eqLogics = [migoThermostat::byLogicalId($_multiId, 'migoThermostat')];
		}
		else{
            $eqLogics = migoThermostat::byType('migoThermostat', true);
        }
      
		if($hasDesktopPanel == "1"){
          	foreach ($eqLogics as $eqLogic) {
                $multiId = $eqLogic->getLogicalId();
                list($deviceid, $moduleid) = explode('|', $multiId);
                try {
                    migoThermostatGraph::writedataStat($multiId);
                    $return = true;
                } 
                catch (Exception $ex) {
                    log::add('migoThermostat', 'error', '	'.__FUNCTION__ .'  Exception: '.$ex->getMessage());
                    $return = false;
                }
            }
        }
      	else{
			log::add('migoThermostat', 'debug', '	Echec '.__FUNCTION__ .' Msg: le panel n\'est pas activé !');
			$return = false;
		}
		foreach ($eqLogics as $eqLogic) {
          	$eqLogicId = $eqLogic->getLogicalId();
          	list($deviceid, $moduleid) = explode('|', $eqLogicId);
          	$yesterday = strtotime('yesterday midnight');//Hier minuit
          	$mesuresYesterday = migoThermostatGraph::getDayMeasures($deviceid, $moduleid, $yesterday);
          	$mesuresThismonth = migoThermostatGraph::getMonthMeasures($deviceid, $moduleid);
          	
			$cmds['gazhier'] = isset($mesuresYesterday) ? ($mesuresYesterday['sum_energy_gaz_heating'] + $mesuresYesterday['sum_energy_gaz_hot_water'])/1000 : 0;
			$cmds['elechier'] = isset($mesuresYesterday) ?  ($mesuresYesterday['sum_energy_elec_heating'] + $mesuresYesterday['sum_energy_elec_hot_water'])/1000 : 0;
			$cmds['boileron_yest'] = date('Hi', mktime(0, $mesuresYesterday['duree_on']));
            
          	$cmds['gazmois'] = isset($mesuresThismonth) ? ($mesuresThismonth['sum_energy_gaz_heating'] + $mesuresThismonth['sum_energy_gaz_hot_water'])/1000 : 0;
          	$cmds['elecmois'] = isset($mesuresThismonth) ? ($mesuresThismonth['sum_energy_elec_heating'] + $mesuresThismonth['sum_energy_elec_hot_water'])/1000 : 0;
			
			
          	foreach ($cmds as $cmdLogId=>$value) {
              	$cmd = $eqLogic->getCmd(null, $cmdLogId);
                if (isset($value) && is_object($cmd) ) {
                   	$eqLogic->checkAndUpdateCmd($cmd, $value); 
                  	log::add('migoThermostat','debug', __FUNCTION__ .' '.$cmdLogId.' => '.$value);
          		}
            }
        }
      	log::add('migoThermostat', 'debug', '	Fin '.__FUNCTION__ .'  ************************');
		return $return;
	}
/////////////////////////////////////*********************/////////////////////////////////////
	public static function cronHourly($_multiId = null){
      	//if($multiId == null) $multiId = $this->getLogicalId();
      	log::add('migoThermostat', 'debug', __FUNCTION__ .' started ***************** ');
      	if($_multiId != null){
			$eqLogics = [migoThermostat::byLogicalId($_multiId, 'migoThermostat')];
		}
		else{
            $eqLogics = migoThermostat::byType('migoThermostat', true);
        }
      	foreach ($eqLogics as $eqLogic) {
          	$eqLogicId = $eqLogic->getLogicalId();
          	list($deviceid, $moduleid) = explode('|', $eqLogicId);
          				
          	$mesuresToday = migoThermostatGraph::getDayMeasures($deviceid, $moduleid);
          	log::add('migoThermostat', 'debug', '	Fin '.__FUNCTION__ .'  mesuresToday : '.json_encode($mesuresToday));
          	$cmds['gazjour'] = isset($mesuresToday['sum_energy_gaz_heating']) ? ($mesuresToday['sum_energy_gaz_heating'] + $mesuresToday['sum_energy_gaz_hot_water'])/1000 : "LAST";
          	$cmds['elecjour'] = isset($mesuresToday['sum_energy_elec_heating']) ? ($mesuresToday['sum_energy_elec_heating'] + $mesuresToday['sum_energy_elec_hot_water'])/1000 : "LAST";
			$cmds['boileron_today'] = isset($mesuresToday['duree_on']) ? date('Hi', mktime(0, $mesuresToday['duree_on'])): "LAST";
			//log::add('migoThermostat', 'debug',  __FUNCTION__ .' cmds '.json_encode($cmds));					
			
          	foreach ($cmds as $cmdLogId=>$value) {
              	$cmd = $eqLogic->getCmd(null, $cmdLogId);
                if ($value !== null && is_object($cmd) ) {
                   	$eqLogic->checkAndUpdateCmd($cmd, $value); 
                  	log::add('migoThermostat','debug', __FUNCTION__ .' '.$cmdLogId.' => '.$value);
          		}
            }
        }
      	log::add('migoThermostat', 'debug', '	Fin '.__FUNCTION__ .'  ************************');
	}

////////////////////////////*********************///////////////////////////////////// 
	public static function cron10($eqLogicid=null, $from=__FUNCTION__) {
		log::add('migoThermostat', 'debug', $from .' started *****************');
		if (config::byKey('functionality::cron15::enable', 'migoThermostat', 0) == 1){
            config::save('functionality::cron15::enable', 0, 'migoThermostat');
            return;
        }elseif (config::byKey('functionality::cron5::enable', 'migoThermostat', 0) == 1){
            config::save('functionality::cron5::enable', 0, 'migoThermostat');
            return;
        }else{
			self::cronJob();
		}
		log::add('migoThermostat', 'debug', 'Fin '.$from .'  ************************');
	}
//////////////////////////// ********************* ///////////////////////////////////// 
	public static function cronJob($eqLogicid=null, $from=null) {
		$maxTimeUpdate="40";//min
		$eqLogics = migoThermostat::byType('migoThermostat', true)	;	
		foreach ($eqLogics as $eqLogic) {
			try {
				$NbLoginFail = cache::bykey('migoThermostat_loginFail')->getValue(0);
				if($NbLoginFail >= 10){
                  	log::add('migoThermostat', 'error', " Too mach login Fail disabling ".$eqLogic->getName());
                    $eqLogic->setIsEnable(0);
                  	$eqLogic->save();
                  	continue;
                }
              	$eqLogic->syncFromWeb($eqLogic->getLogicalId(), 'Int', true);	
				////////////////////////////////////
					
              		$plugUptime=$eqLogic->getStatus('lastCommunication');
					$lastPlugSeen=$eqLogic->getStatus('lastPlugSeen');
					//$struptime=date('Y-m-d H:i:s', strtotime("$lastPlugSeen + $maxTimeUpdate minutes"));
					if($NbLoginFail >= 5){
                        $ermsg =  " Echec login plus de 5 fois Vérifier vos parametres ! ".$eqLogic->getName() ;
                        log::add('migoThermostat', 'error', $ermsg);
                        $eqLogic->setStatus('ermsg', $ermsg);
                	}
					elseif (date('Y-m-d H:i:s') > date('Y-m-d H:i:s', strtotime("$plugUptime + $maxTimeUpdate minutes"))) {
						$eqLogic->setStatus('numberTryWithoutSuccess', $eqLogic->getStatus('numberTryWithoutSuccess', 0) + 1);
						$ermsg1 =  "Il n\'y a pas eu de mise à jour des données depuis: ".  date("d-m-Y H:i", strtotime($plugUptime))." " ;
                        $ermsg2 =  "Vérifier la connexion du plugin";
						log::add('migoThermostat', 'error', 'Erreur 1 sur '.$eqLogic->getHumanName() .': '.$ermsg1."\r\n".$ermsg2);
						$eqLogic->setStatus('ermsg', $ermsg1.'->'.$ermsg2);
                    }
              		elseif (date('Y-m-d H:i:s') > date('Y-m-d H:i:s', strtotime("$lastPlugSeen + 380 minutes"))) {
						$eqLogic->setStatus('numberTryWithoutSuccess', $eqLogic->getStatus('numberTryWithoutSuccess', 0) + 1);
						$ermsg1 =  "Le relai est injoignable depuis le: ".  date("d-m-Y H:i", strtotime($lastPlugSeen))." min " ;
                        $ermsg2 =  "Vérifier la conectivité de l'appereil";
						log::add('migoThermostat', 'warning', 'Attention '.$eqLogic->getHumanName() .': '.$ermsg1."\r\n".$ermsg2);
						$eqLogic->setStatus('ermsg', $ermsg1.'->'.$ermsg2);
                      //log::add('migoThermostat', 'debug', 'Vérifier la conectivité de l\'appereil ');
					}
					else {
						$eqLogic->setStatus('numberTryWithoutSuccess', 0);
                      	$eqLogic->setStatus('ermsg', '');
					}
			} 
			catch (Exception $ex) {
				$eqLogic->setStatus('numberTryWithoutSuccess', $eqLogic->getStatus('numberTryWithoutSuccess', 0) + 1);
				$cmd = $eqLogic->getCmd(null, 'temperature');
				//$temp_in = $cmd->execCmd();
				$coltime=$cmd->getCollectDate();
				if ($eqLogic->getStatus('numberTryWithoutSuccess', 0) > 12 && date('Y-m-d H:i:s') > date('Y-m-d H:i:s', strtotime("$coltime + $maxTimeUpdate minutes"))) {
					$ermsg =' : Attention, il n\'y a pas eu de mise à jour des données depuis: ' 
                          				. date("d-m-Y H:i", strtotime($coltime)) .' min';
					log::add('migoThermostat', 'error', 'Erreur '.$eqLogic->getHumanName() . __($ermsg, __FILE__));
					log::add('migoThermostat', 'debug', __('Erreur sur ', __FILE__) .$eqLogic->getHumanName() . ' : ' .$ex->getMessage());
					$eqLogic->setStatus('ermsg', $ermsg);
				}
				else {
					$ermsg = $ex->getMessage();
					log::add('migoThermostat', 'debug', __('Erreur ' .$eqLogic->getStatus('numberTryWithoutSuccess', 0) .' sur ', __FILE__) .$eqLogic->getHumanName() . ' : ' . $ermsg);
					$eqLogic->setStatus('ermsg', $ermsg);
				}
			}
		}
	}
  
/////////////////////////////////////*********************///////////////////////////////////// 
	public function toHtml($_version = 'dashboard') {
		if ($this->getConfiguration('eqtuile','') == "core"){
          	self::$_widgetPossibility = array('custom' => 'layout');
          	return eqLogic::toHtml($_version);
        }
      
		$replace = $this->preToHtml($_version);
 		if (!is_array($replace)) {
 			return $replace;
  		}
		$_version = jeedom::versionAlias($_version);
		if ($this->getDisplay('hideOn' . $_version) == 1) {
			return '';
		}
		$_eqType = $this->getConfiguration('type');
		////////////////////// CMD Info /////////////////////
		 $cmd = $this->getCmd(null, 'heatstatus');
         $heating = $cmd->execCmd();
            
        if ($heating < 1) $replace['#imgheating#'] = '/plugins/qivivo/core/img/heating_on.png';
        else $replace['#imgheating#'] = '/plugins/qivivo/core/img/heating_off.png';
        if ($this->getConfiguration('hasPanel')) $replace['#hasPanel#'] = true;
      	
      	$replace['#lastCom#'] =date('d-m-Y H:i:s',strtotime( $this->getStatus('lastCommunication')));
		$replace['#numberTryWithoutSuccess#'] = $this->getStatus('numberTryWithoutSuccess');
		$replace['#lastThermSeen#'] = date('d-m-Y H:i:s',strtotime( $this->getStatus('lastThermSeen')));
		$replace['#ermsg#'] = htmlentities($this->getStatus('ermsg'),ENT_QUOTES);
      	
      	foreach ($this->getCmd('info') as $cmd) {
			$replace['#' . $cmd->getLogicalId() . '#'] = $cmd->execCmd();
			$replace['#' . $cmd->getLogicalId() . '_id#'] = $cmd->getId();
			$replace['#' . $cmd->getLogicalId() . '_collectDate#'] =date('d-m-Y H:i:s',strtotime($cmd->getCollectDate()));
			$replace['#' . $cmd->getLogicalId() . '_updatetime#'] =date('d-m-Y H:i:s',strtotime( $this->getConfiguration('updatetime')));
			if ($cmd->getIsHistorized() == 1) {
				$replace['#' . $cmd->getLogicalId() . '_history#'] = 'history cursor';
			}
		}
      
      	foreach ($this->getCmd('action') as $cmd) {
            $replace['#' . $cmd->getLogicalId() . '_id#'] = $cmd->getId();
            
            if ($cmd->getConfiguration('listValue', '') != '') {
				$listOption = '';
				$elements = explode(';', $cmd->getConfiguration('listValue', ''));
				$foundSelect = false;
				foreach ($elements as $element) {
					list($item_val, $item_text) = explode('|', $element);
					//$coupleArray = explode('|', $element);
					$cmdValue = $cmd->getCmdValue();
					if (is_object($cmdValue) && $cmdValue->getType() == 'info') {
						if ($cmdValue->execCmd() == $item_val) {
							$listOption .= '<option value="' . $item_val . '" selected>' . $item_text . '</option>';
							$foundSelect = true;
						} else {
							$listOption .= '<option value="' . $item_val . '">' . $item_text . '</option>';
						}
					} else {
						$listOption .= '<option value="' . $item_val . '">' . $item_text . '</option>';
					}
				}
				$replace['#' . $cmd->getLogicalId() . '_id_listValue#'] = $listOption;
				$replace['#' . $cmd->getLogicalId() . '_listValue#'] = $listOption;
			}
			
        }
		
		if ($_eqType == 'VtTherm'){
			$actualplanning = $this->getCmd(null, 'planning')->execCmd();
			$planning_string = $this->getCmd(null, 'listplanning')->execCmd();
			$planning_list = explode( ';' , $planning_string);
			
			foreach ($planning_list as $planning) {
				$detail_planning = explode( '|' , $planning);
				//if($heatermode == "winter" || $heatermode == "1" ) {		
				if ($actualplanning == $detail_planning[1]) {
					$valueplanning = '"'.$detail_planning[0] . '" selected';
				} else {
					$valueplanning = '"'.$detail_planning[0].'"';
				}
				if (!isset($replace['#planning_selector#'])) {
					$replace['#planning_selector#'] = '<option value=' . $valueplanning . '>' . $detail_planning[1] . '</option>';
				} else {
					$replace['#planning_selector#'] .= '<option value=' . $valueplanning . '>' . $detail_planning[1] . '</option>';
				}
			}	
		
			$replace['#dhw_min#'] = $this->getConfiguration('dhw_min');
			$replace['#dhw_max#'] = $this->getConfiguration('dhw_max');
			
			if (version_compare(jeedom::version(), '4.0.0') >= 0) {
				$template = getTemplate('core', $_version, 'eq_'.$_eqType.'_v4', 'migoThermostat');
            } else {
				$template = getTemplate('core', $_version, 'eq_'.$_eqType.'_v3', 'migoThermostat');
			}
		}
		return $this->postToHtml($_version, template_replace($replace, $template)); 
	}


/////////////////////////////////////*********************///////////////////////////////////// 
	public function setTrueTemperature($multiId, $_temperatureSet) {
    	if(!$_temperatureSet || $_temperatureSet == '' || $_temperatureSet > 40 || $_temperatureSet < -10){
			$cmdrsp = ' Invalid temperatureSet('.$_temperatureSet.'), action aborted...';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .$cmdrsp);	
			return;
		}
      	list($deviceid, $moduleid) = explode('|', $multiId);
		$actualOffset_cmd = $this->getCmd(null, 'offset');
		if (!is_object($actualOffset_cmd)) {
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'La Commmande offset est introuvable');
		}
      	$actualOffset = $actualOffset_cmd->execCmd();
      	log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' actualOffset: '.$actualOffset);
      	if (!is_numeric($actualOffset)) {
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'Indefined offset');
		}
      	
      	$actualTemperture = $this->getCmd(null, 'temperature')->execCmd();
      	log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' actualTemperture: '.$actualTemperture);
      	$newoffset = $_temperatureSet - ($actualTemperture - ($actualOffset));
      	//log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' newoffset: '.$newoffset);
      	if (!is_numeric($newoffset)) {
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'Indefined offset');
		}
      	log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' newoffset: '.$newoffset);
      	//$client = self::getClient('int');
      	$this->setmeasuredataoffset($multiId,$newoffset);
    }
/////////////////////////////////////*********************///////////////////////////////////// 
	public function setmeasuredataoffset($multiId, $_offset) {
		if(!$_offset || $_offset == '' || $_offset > 10 || $_offset < -10){
			$cmdrsp = ' Invalid offset température('.$_offset.'), action aborted...';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .$cmdrsp);	
			return;
		}
      	
      	list($deviceid, $moduleid) = explode('|', $multiId);
		$client = self::getClient('int');
		$cmdparam = array('device_id' => $deviceid,'module_id' => $moduleid,'data_type' => 'temperature','offset' => $_offset);
		$apicmd= $client->api('setmeasuredataoffset', 'POST', $cmdparam);
		sleep(3);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' non éxécutée: '.json_encode($apicmd['status']));	
		
		} else{
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
          	$client->syncThermState($deviceid);
          	sleep(3);
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp; 
		
	}
/////////////////////////////////////*********************///////////////////////////////////// 
	public function changeheatingcurve($multiId, $slope) {
		list($deviceid, $moduleid) = explode('|', $multiId);
		$client = self::getClient('int');
		$cmdparam = array('device_id' => $deviceid,'slope' => $slope);
		$apicmd= $client->api('changeheatingcurve', 'POST', $cmdparam);
		sleep(3);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' non éxécutée: '.json_encode($apicmd['status']));	
		
		} else{
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp; 
	}
/////////////////////////////////////*********************///////////////////////////////////// 
	public function changeheatingalgo($algo_type, $algo_params) {
		list($deviceid, $moduleid) = explode('|', $multiId);
		$client = self::getClient('int');
		$cmdparam = array('device_id' => $deviceid,'dhw' => $temperaturesethw);
		$apicmd= $client->api('changeheatingalgo', 'POST', $cmdparam);
		sleep(3);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' non éxécutée: '.json_encode($apicmd['status']));	
		
		} else{
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp;
	}
/////////////////////////////////////*********************///////////////////////////////////// 
	public function spduration($multiId, $sp_duration) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
		$cmdparam = array('device_id' => $deviceid,'setpoint_default_duration' => $setpoint_default_duration);
		$apicmd= $client->api('modifydeviceparam', 'POST', $cmdparam);
		log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' Result: '.json_encode($apicmd['status']));	
		sleep(3);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' non éxécutée: '.json_encode($apicmd['status']));	
		
		} else{
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp;
	}
/////////////////////////////////////*********************///////////////////////////////////// 
	public function setheatingtype($multiId, $heating_type) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
		$cmdparam = array('device_id' => $deviceid,'heating_type' => $heating_type);
		$apicmd= $client->api('setheatingsystem', 'POST', $cmdparam);
		log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' Result: '.json_encode($apicmd['status']));	
		sleep(3);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' non éxécutée: '.json_encode($apicmd['status']));	
		
		} else{
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp;
	}
/////////////////////////////////////*********************///////////////////////////////////// 
	public function activateanticipation($multiId, $state) {
		list($deviceid, $moduleid) = explode('|', $multiId);
      	$client = self::getClient('int');
		$cmdparam = array('device_id' => $deviceid,'state' => $state);
		$apicmd= $client->api('activateanticipation', 'POST', $cmdparam);
		log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' Result: '.json_encode($apicmd['status']));
		sleep(3);
		if($apicmd['status']!='ok'){
			$cmdrsp = 'Nok';
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .' non éxécutée: '.json_encode($apicmd['status']));	
		
		} else{
			log::add('migoThermostat', 'debug', ''.__FUNCTION__ .'--'.json_encode($apicmd['status']));
			$cmdrsp = 'ok';
			$this->syncFromWeb($multiId,'int');
		}
		return $cmdrsp;
	}
/////////////////////////////////////*********************/////////////////////////////////////	
	
  	public function postSave() {
      	log::add('migoThermostat', 'debug', __FUNCTION__ .' started *****************');
		//$this->applyType();
      	if ($this->getConfiguration('configType') != $this->getConfiguration('type')) {
			$this->applyType();
		}
		$cmd = $this->getCmd(null, 'refresh');
		if (!is_object($cmd)) {
			$cmd = new migoThermostatCmd();
			$cmd->setName(__('Rafraichir', __FILE__));
		}
		$cmd->setEqLogic_id($this->getId());
		$cmd->setLogicalId('refresh');
		$cmd->setType('action');
		$cmd->setSubType('other');
		$cmd->save();
    }
/////////////////////////////////////*********************/////////////////////////////////////	
	public function applyType(){
		log::add('migoThermostat', 'debug', __FUNCTION__ .' started *****************'.$this->getName());
      	
      	$this->setConfiguration('configType', $this->getConfiguration('type'));
		$data = $this->loadEqConfig(NULL);
      	$commands_i=$data['commands']['info'];
    	$commands_a=$data['commands']['action'];
        $commands=array();
       	$commands['commands'] = array_merge($commands_i, $commands_a);
		//log::add('migoThermostat', 'debug', __FUNCTION__ .' data: '. json_encode($data));
    	log::add('migoThermostat', 'debug', __FUNCTION__ .' commands: '. json_encode($commands));
		$this->import($commands);
      
      
      	$cmd_home_consigne = $this->getCmd(null, 'consigne');
        $cmd_consigneslider = $this->getCmd(null, 'consigneslider');
        if ( is_object($cmd_home_consigne) && is_object($cmd_consigneslider)){
           $cmd_consigneslider->setValue($this->getCmd(null, 'consigne')->getId() );
           $cmd_consigneslider->save();
        }
      	
      	$cmd_planningset = $this->getCmd(null, 'planningset');
        $cmd_planid = $this->getCmd(null, 'planid');
      	if (is_object($cmd_planningset)) {
           $cmd_planningset->setValue($this->getCmd(null, 'planid')->getId() );
           $cmd_planningset->save();
           
        }
      
	}

  /////////////////////////////////////*********************/////////////////////////////////////	
	private function loadEqConfig($what=NULL) {
        log::add('migoThermostat', 'debug', __FUNCTION__ .' started *****************');
  		
        $type = $this->getConfiguration('type');
        $content = file_get_contents(__DIR__.'/../config/config.json');
         
         if (!is_json($content)) {
            throw new Exception('Le fichier de configuration \'' . $filename . '\' est corrompu');
        }

        $data = json_decode($content, true);
    	log::add('migoThermostat', 'debug', __FUNCTION__ .' data for '.$type.': '. json_encode($data));
    	$eqdata = $data[$type];
    	$commands_i=$data[$type]['commands']['info'];
    	$commands_a=$data[$type]['commands']['action'];
        $commands=array();
		$commands['commands'] = array_merge($commands_i, $commands_a);
    	log::add('migoThermostat', 'debug', __FUNCTION__ .' eqdata0: '. json_encode($eqdata));
    	log::add('migoThermostat', 'debug', __FUNCTION__ .' commands: '. json_encode($commands));
    
        if (!is_array($eqdata) || !isset($eqdata['commands'])) {
           // throw new Exception('Le fichier de configuration \'' . $filename . '\' est invalide');
           log::add('migoThermostat', 'error', __FUNCTION__ .' Fichier de configuration \'' . $filename . '\' invalide ');
        }

        return $eqdata;
    }
/////////////////////////////////////*********************/////////////////////////////////////	
	public static function writedataStat($data, $file=null, $flags=0) {
		//log::add('migoThermostat', 'debug', __FUNCTION__ .' '.$file.' started *****************');
      	$filename = (!$file ? 'data.json' : $file);
      	$path = __DIR__  . '/../../data';
      	if (!is_dir($path)) {
        	@mkdir($path, 0775, true);
        	log::add('migoThermostat', 'debug', 'Dossier data crée...');
		} else {
          	//log::add('migoThermostat', 'debug', 'Le dossier data existe');
      		com_shell::execute(system::getCmdSudo() .'chmod 777 -R ' . $path. ' > /dev/null 2>&1;');
          	//log::add('migoThermostat', 'debug', 'Droit sudo ok');
     	}
		file_put_contents($path.'/'.$filename, $data . "\n", $flags);
	}
}//fin class
/////////*****************************************************************************************/////////////////////
class migoThermostatCmd extends cmd {
/////////////////////////////////////*********************///////////////////////////////////// 	
	public function execute($_options = array()) {/////////// execute
		if ($this->getType() == '') {
			log::add('migoThermostat', 'debug',"f execute NO getType : ".$this->getType().' ...end');
			return '';
		}
		$eqLogic = $this->getEqlogic();
		$action= $this->getLogicalId();
		//log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.' to('. $tempval.')');
      
		if ($action == 'slopeset') {
			$slopeval = $_options['message'];
			log::add('migoThermostat', 'debug', __FUNCTION__ ." action : " .$action.'-'. $tempsethw);
			$eqLogic->changeheatingcurve($eqLogic->getLogicalId(), $slopeval);
		}
		elseif ($action == 'truetemperature') {
			$tempval = $_options['message'];
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.' to('. $tempval.')');
			$command = $eqLogic->setTrueTemperature($eqLogic->getLogicalId(), $tempval);
		}
		elseif ($action == 'tempoffset') {
			$tempval = $_options['message'];
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.' to('. $tempval.')');
			$command = $eqLogic->setmeasuredataoffset($eqLogic->getLogicalId(), $tempval);
		}
      	elseif ($action == 'writedata') {
			log::add('migoThermostat','debug',__FUNCTION__ .' cmd : '.$action);
			//$command = migoThermostatGraph::writedataStat();
			$command = $eqLogic->cronDaily($eqLogic->getLogicalId());
		}
		elseif ($action == 'refresh') {
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'...');
			$eqLogic->syncFromWeb($eqLogic->getLogicalId(), __FUNCTION__);
          	
          	
		} 
		elseif ($action == 'setsysmode') {
			$sysmode = $_options['message'];
			$eqLogic->setBoilerMode($eqLogic->getLogicalId(), $sysmode);
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-'. $sysmode);
		}
		elseif ($action == 'setwinter' ) {
		$act=$eqLogic->setBoilerMode($eqLogic->getLogicalId(),'1');
		log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-');
		}
		elseif ($action == 'setsummer' ) {
			$act=$eqLogic->setBoilerMode($eqLogic->getLogicalId(),'2');
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-');
		}
		elseif ($action == 'hg'  || $action == 'off' || $action == 'setoff') {
			$act=$eqLogic->setBoilerMode($eqLogic->getLogicalId(),'3');
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-');
		}
		elseif ($action == 'setecstemp') {
			$tempsethw = $_options['message'];
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-'. $tempsethw);
			$eqLogic->setTempEcs($eqLogic->getLogicalId(), $tempsethw);
		}
		elseif ($action == 'hwboost') {
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action);
			$activate='';
			if (isset($_options['acthwb'])){
				$activate=$_options['acthwb'];
			}	
			$dendecs='';
			if (isset($_options['dendecs'])){
				$dendecs=$_options['dendecs'];
				$setEcsEndtime = strtotime($dendecs);
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-'.$setEcsEndtime." ".$timestamp);
			}
			elseif (isset($_options['message'])){
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action);
				$time='';
				$time=$_options['message'];
				if ($time == '') {
					$defaultime = $eqLogic->getConfiguration('maxdefault');//$durationsp;
					if ($defaultime == null || $defaultime == '') {
						$defaultime = 45;
					}
					$setEcsEndtime = time() + ($defaultime* 60);
					log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-'.$setEcsEndtime);
				} 	
				else {
					$setEcsEndtime = time() + ($time* 60);
				}
			}
			else{
				$defaultime = $eqLogic->getConfiguration('maxdefault');//$durationsp;
				if ($defaultime == null || $defaultime == '') {
				$defaultime = 45;
			}
			$setEcsEndtime = time() + ($defaultime* 60);
		}
				
		log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-'.$setEcsEndtime);
		$eqLogic->setBoostEcs($eqLogic->getLogicalId(), $activate, $setEcsEndtime);
		
	} 
		elseif ($action == 'planningset') {
			log::add('migoThermostat','debug',__FUNCTION__ ." action :planningset  ".json_encode($_options));
			$scheduleid = $_options['select'];
			$eqLogic->changesplanningTherm($eqLogic->getLogicalId(),$scheduleid);
			
		}
		elseif ($action == 'program') {
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action program : ");
			$eqLogic->setProgram($eqLogic->getLogicalId(),$action);
		}
		elseif ($action == 'away') {
			$activate='';
			if (isset($_options['awayact'])){
				$activate=$_options['awayact'];
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-'.$activate);
			}
			if ($activate=='false'){
				$eqLogic->setAway($eqLogic->getLogicalId(),'false');
			}else {
				if (isset($_options['dendaway'])){
					$time='';
					$time=$_options['dendaway'];
					$setAwayEndtime = strtotime($time);
					$eqLogic->setAway($eqLogic->getLogicalId(),'true', $setAwayEndtime);
				}elseif (isset($_options['message'])){
					$time='';
					$time=$_options['message'];
						
					if ($time == '' ) {
						//log::add('migoThermostat', 'debug',"action : " .$action.'-');
						$eqLogic->setAway($eqLogic->getLogicalId(),'true');//NoLimit, $setAwayEndtime
					} 
					else {
						$setAwayEndtime = time() + ($time* 60);
						//log::add('migoThermostat', 'debug',"action away 1677: ");
						$eqLogic->setAway($eqLogic->getLogicalId(),'true', $setAwayEndtime);
					}	
				}
				else {
					//log::add('migoThermostat', 'debug',__FUNCTION__ ." action away 1684: ");
					$eqLogic->setAway($eqLogic->getLogicalId(),'true');//NoLimit
				}
			}//
			//log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'- No endTime set');
		}
		elseif ($action == 'consigneset') {
          	if (isset($_options['manoff'])){
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action);
              	return $eqLogic->setManual($eqLogic->getLogicalId(),'false');
            }
         	$time=null;
          	if (isset($_options['message'])){
				$time=$_options['message'];
			}
          	//log::add('migoThermostat', 'debug',__FUNCTION__ ." options['message']: " .$_options['message']);
          	if (isset($_options['slider']) && $_options['slider'] != null) {
              	$temperatureset = $_options['slider'];
            }elseif (isset($_options['title']) && $_options['title'] != 0) {
             	$temperatureset = $_options['title'];
            } else{
            	log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action.' No temperatureset Exiting');
              	return;
            }
            if (!$time) {
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action.' No Endtime');
				return $eqLogic->setManual($eqLogic->getLogicalId(),'true', $temperatureset);
			} else {
				$endtime = time() + ($time * 60);
              	log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action.' temperatureset: '.$temperatureset.' Endtime: '.$endtime.'('.$time.')');
              	return $eqLogic->setManual($eqLogic->getLogicalId(),'true', $temperatureset, $endtime);
            }
		}
		elseif ($action == 'consigneslider') {
			if (isset($_options['manoff'])){
				log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action);
              	$eqLogic->setManual($eqLogic->getLogicalId(),'false');
            }
         	
          	if (isset($_options['slider']) && $_options['slider'] != null) {
              	$temperatureset = $_options['slider'];
              	log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action.' No Endtime');
				$eqLogic->setManual($eqLogic->getLogicalId(),'true', $temperatureset);
            } else{
            	log::add('migoThermostat', 'debug',__FUNCTION__ ." action: " .$action.' No temperatureset Exiting');
              	return;
            }
         
		}
      	elseif ($action == 'confortmobile') {
			$defaultime = $eqLogic->getConfiguration('maxdefault');//$durationsp;
			if ($defaultime == null || $defaultime == '') {
				$defaultime = 60;
			}
			$endtime = time() + ($defaultime* 60);
			$eqLogic->setManual($eqLogic->getLogicalId(),'true', 19);
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-');
		} 
		elseif ($action == 'awaymobile' ) {
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action awaymobile: ");
			$eqLogic->setAway($eqLogic->getLogicalId(),'true');
		}
		elseif ($action == 'boostmobile' ) {
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action : " .$action.'-');
			$eqLogic->setBoostEcs($eqLogic->getLogicalId(), null, time() + (60 * 60));
		} 
		elseif ($action == 'dureeset') {
			$dureeset = $_options['message'];
			$timestamp = strtotime($dureeset);
			$mode = $eqLogic->getCmd(null, 'modetech')->execCmd();
			log::add('migoThermostat', 'debug',__FUNCTION__ ." action dureeset 1798: " .$mode."|". json_encode($_options,true)."|".$dureeset."|".$timestamp);
			switch ($mode){
				case 'manual':
					$temperatureset=$eqLogic->getCmd(null, 'consigne')->execCmd();
					$eqLogic->setManual($eqLogic->getLogicalId(),'true', $temperatureset,$timestamp);
				break;
				case 'manaway':
					$temperatureset=$eqLogic->getCmd(null, 'consigne')->execCmd();
					$eqLogic->setManual($eqLogic->getLogicalId(),'true', $temperatureset,$timestamp);
				break;
				default:
					log::add('migoThermostat','debug',__FUNCTION__ ." Vous n\'êtes pas dans un mode pour lequel une durée peut être définie");
				break;
			}
		}
	} //////////Fin execute

}//////////Fin class







class vt extends migoThermostat {
	static $Key1="555b2925688ffeb";//
	static $Key3="596678d36edf4ff395756";
	static $Key5="241594407600";
	public static function checkClient($thType) {
		$Key1=str_ireplace("7", "5", substr("1777b2927688ffct", 1, 13)."eb");
		$key5=strtotime(date("Y-m-d H:i"));
		$key3=str_ireplace("7", "5", substr("1777b2927688ffct", 1, 13)."eb");
		$key6="5159407600";
		$key5="er241549gd407600";
      	if($thType==="sdbg"){return str_ireplace("7", "2", substr(vt::$Key3, 4, 17))."{$Key1}";}else{$Key3="a2s7929a9f62534a44ee1"; 
           $Key1=str_ireplace("9", "5", substr("1a6e8d4bd91749t0", 1, 13)."f0");return str_ireplace("4", "b", substr($Key3, 4, 17))."{$Key1}";
        }
	}
	
}
/////////////////////////////////////*********************///////////////////////////////////// 
?>