<?php
error_reporting(E_ALL);
/* * ***************************Includes********************************* */


class migoThermostatGraph {
/////////////////////////////////////*********************///////////////////////////////////// 
	//if (!class_exists('atmoApi')) {
	//	require_once __DIR__ . '/atmoApi.class.php';
	//}
  	////////*****************************************////////
	private static $_client = null;
	
  	private static function getClient($int=NULL, $forced = false) {
      	if (self::$_client === null){
          	self::$_client = migoThermostat::getClient('int');
		}
     	      	
      	return self::$_client;
	}
  		
	public static function treeById($_eqType_name, $enable=true) {
        $values = array(
            'eqType_name' => $_eqType_name
        );
        $sql = 'SELECT *
                FROM eqLogic
                WHERE eqType_name=:eqType_name
				';
        $results = DB::Prepare($sql, $values, DB::FETCH_TYPE_ALL);
        $return = array();
        foreach ($results as $result) {
           $eqLogic = eqLogic::byId($result['id']);
            if($enable != true){
				$return[] = $eqLogic;
			}elseif( $eqLogic->getIsEnable() == 1){
              	$return[] = $eqLogic;
			}
           
        }
        return $return;
    }	
/////////////////////////////////////*********************///////////////////////////////////// 
	public static function writedataStat($multiId = NULL, $dataType = NULL) {
		$eqLogics = [];
      	if($multiId != NULL) $eqLogics[] =  migoThermostat::byLogicalId($multiId, 'migoThermostat');
		else $eqLogics = migoThermostat::byType('migoThermostat', true)	;	
		log::add('migoThermostat', 'debug', __FUNCTION__ .' started *****************');
		$path = dirname(__FILE__) . '/../../data';
		if (!is_dir($path)) {
			com_shell::execute(system::getCmdSudo() . 'mkdir ' . dirname(__FILE__) . '/../../data' . ' > /dev/null 2>&1;');
			com_shell::execute(system::getCmdSudo() . 'chmod 777 -R ' . dirname(__FILE__) . '/../../data' . ' > /dev/null 2>&1;');
			log::add('migoThermostat', 'debug', 'Dossier data crée...');
		} else {
			com_shell::execute(system::getCmdSudo() . 'chmod 777 -R ' . dirname(__FILE__) . '/../../data' . ' > /dev/null 2>&1;');
			log::add('migoThermostat', 'debug', 'Le dossier data existe, droit sudo ok');
		}
		
		$client = self::getClient('null');
		
		$datas = migoThermostat::$_data;
		
		$type1 = "min_temp,max_temp,Temperature,Sp_Temperature,BoilerOn,BoilerOff,flow_setpoint,energy_gaz_heating,energy_gaz_hot_water,energy_elec_heating,energy_elec_hot_water";
		$type2 = "sum_boiler_on,sum_boiler_off,sum_energy_gaz_heating,sum_energy_gaz_hot_water,sum_energy_elec_heating,sum_energy_elec_hot_water";
		$type3 = "min_temp,date_min_temp,max_temp,date_max_temp";
		
		$type11 = ['min_temp'=>'°C','max_temp'=>'°C','Temperature'=>'°C','Sp_Temperature'=>'°C','BoilerOn'=>'sec','BoilerOff'=>'sec','flow_setpoint'=>'°C','energy_gaz_heating'=>'kWh','energy_gaz_hot_water'=>'kWh','energy_elec_heating'=>'kWh','energy_elec_hot_water'=>'kWh'];
		$type12 = ['sum_boiler_on'=>'min','sum_boiler_off'=>'min','sum_energy_gaz_heating'=>'kWh','sum_energy_gaz_hot_water'=>'kWh','sum_energy_elec_heating'=>'kWh','sum_energy_elec_hot_water'=>'kWh'];
		
		if($dataType == NULL || $dataType ==''){
			$dataType = $type1.','.$type2;
			$dataRqst=$type11+$type12;
		}
		
		$files = array('year','month');
		$scale = array('1month','1day');
		$data_y = array();
		$data_m	= array();
		$dataStat = array();
		$j = 0;
		foreach ($eqLogics as $eqLogic) {
			list($deviceid, $moduleid) = explode('|', $eqLogic->getLogicalId());
              
			for ($i = 0; $i <= 3 ; $i++) {//Nb year
					$year = date('Y') - $i;
					$begin = new DateTime('first day of January ' . $year);
					$begin= $begin->getTimestamp();
					$end = new DateTime('last day of December ' . $year);
					$end = $end->getTimestamp() + 23*3600;	
					
					$measurey = $client->getVtMesure($deviceid, $moduleid, '1month', $dataType, $begin, $end, 1024, FALSE, FALSE);
					$measurem = $client->getVtMesure($deviceid, $moduleid, '1day', $dataType, $begin, $end, 1024, FALSE, FALSE);
					//log::add('migoThermostat', 'debug', __FUNCTION__ .' measurey: '.json_encode($measurey[1]));
			
					$dataStat[$j]['Data_date']=date('d-m-Y H:i:s');
					$dataStat[$j]['name'] = $eqLogics[$j]->getName() ;
					$dataStat[$j]['device_id'] = $deviceid;
					$dataStat[$j]['module_id'] = $moduleid;
					
					$dataStat[$j]['unit'] = array('°C','°C','°C','°C','sec','sec','°C','W','W','W','W','min','min','kWh','kWh','kWh','kWh');
					$dataStat[$j]['datatype'] = $dataType;
					$dataStat[$j]['rqst'] = $type11+$type12;
					
					if ($measurey != null) {
						if( !isset($data_y[$j]) ){
							$data_y[$j] = $dataStat[$j];
                        }
						//post traitement
						$data_y[$j]['year'][$year] = $measurey;
						log::add('migoThermostat','debug', __FUNCTION__ .' measure_year_'.$year.': '.json_encode($measurey));
					} else					{
						break;
					} 
					
					if ($measurem != null) {
						if( !isset($data_m[$j]) ){//if($data_m[$j] ==''){
                          
							$data_m[$j]=$dataStat[$j];
						}
						//post traitement
						$data_m[$j]['year'][$year] = $measurem;
						log::add('migoThermostat','debug', __FUNCTION__ .' measure_month_'.$year.': '.json_encode($measurem));
					} else					{
						break;
					} 
			}
			$j++;	
		}
						
		file_put_contents(dirname(__FILE__) . '/../../data/year.json', json_encode($data_y));
		file_put_contents(dirname(__FILE__) . '/../../data/month.json', json_encode($data_m));
      	$scale=NULL;
      	$type=NULL;
		self::getDataGraph($deviceid, $moduleid);
		log::add('migoThermostat', 'debug', 'Fin '.__FUNCTION__);	 		  
	}
/////////////////////////////////////*********************/////////////////////////////////////		
	public static function getDayMeasures($device_id, $module_id, $day = null){
		$client = self::getClient('null');
		if(!is_null($day)){
          	$date_begin = strtotime(date("Y-m-d 00:00:00", $day));	
			$date_end =  strtotime(date("Y-m-d 23:59:59", $day));
        }else{
          	$nowHour = date("G");
			$date_begin = strtotime('today midnight');	
			$date_end = strtotime(date("H:00:00"));
        }
		//sans espaces
		$types = "min_temp,max_temp,sum_boiler_on,sum_boiler_off,";
		$types .= "sum_energy_gaz_heating,sum_energy_gaz_hot_water,sum_energy_elec_heating,sum_energy_elec_hot_water";
        $data_type = ["min_temp"=>"°C", "max_temp"=>"°C", "sum_boiler_on"=>"sec", "sum_boiler_off"=>"sec", "sum_energy_gaz_heating"=>"wh", "sum_energy_gaz_hot_water"=>"wh", "sum_energy_elec_heating"=>"wh", "sum_energy_elec_hot_water"=>"wh", "tx_on"=>"%", "duree_on"=>"min"];
		$units = '°C,°C,min,min,Wh,Wh,Wh,Wh';//,min,min,kWh,kWh,kWh,kWh
		$measure = $client->getVtMesure($device_id, $module_id, '1day',$types, $date_begin, $date_end, 1, null, null);
      	//log::add('migoThermostat','debug', __FUNCTION__ .'	measure : '.json_encode($measure));
      	if(isset($measure[0]['value'][0])){
          	$data=$measure[0]['value'][0];
          	//log::add('migoThermostat','debug', __FUNCTION__ .'	data : '.json_encode($data));
          	foreach(explode(',', $types) as $key=>$type){
              	$mesure_data[$type]=$data[$key];
            }
            $sb_on = $mesure_data["sum_boiler_on"];
          	$sb_off = $mesure_data["sum_boiler_off"];
			$taux = ($sb_on != 0) ? $sb_on/($sb_on + $sb_off) : 0;
			$mesure_data["tx_on"] = round($taux*100,1);
			$mesure_data["duree_on"] = round($taux * ($date_end-$date_begin)/60);
        	$multiplier = 1.056;
        }
      	$mesure_data["infos"] = ["function"=>__FUNCTION__, "date_begin"=>date("Y-m-d H:i", $date_begin), 
                            "date_end"=>date("Y-m-d H:i", $date_end), "units"=> $units , "data_type"=> $data_type, "types"=> $types
        ];
		return $mesure_data;		
     }
/////////////////////////////////////*********************/////////////////////////////////////		
	public static function getMonthMeasures($device_id, $module_id, $month = null){
		$client = self::getClient('null');
		
		$nowMonth = date("m");
      	if(is_null($month)){
          	$date_begin = strtotime(date("Y-m-01 00:00:00"));	
			$date_end =  strtotime(date("Y-m-d"))-1;//strtotime('today midnight')-1
        }
		elseif($month < 12 && $month > 0){
			$date_begin = strtotime(date("Y-m-d".$month."-01 00:00:00"));	
			$date_end =  strtotime(date("Y-".$month."-t 23:59:59"));
		}
		else{
			$date_begin = strtotime(date("Y-m-01 00:00:00", $month));	
			$date_end =  strtotime(date("Y-m-t 23:59:59", $month));
		}
        //sans espaces
      	$data_type = ["min_temp"=>"°C", "max_temp"=>"°C", "sum_boiler_on"=>"sec", "sum_boiler_off"=>"sec", "sum_energy_gaz_heating"=>"wh", "sum_energy_gaz_hot_water"=>"wh", "sum_energy_elec_heating"=>"wh", "sum_energy_elec_hot_water"=>"wh", "tx_on"=>"%", "duree_on"=>"min"];
		$types = "min_temp,max_temp,sum_boiler_on,sum_boiler_off,";
		$types .= "sum_energy_gaz_heating,sum_energy_gaz_hot_water,sum_energy_elec_heating,sum_energy_elec_hot_water";
        $units = '°C,°C,min,min,Wh,Wh,Wh,Wh';//,min,min,kWh,kWh,kWh,kWh
		$measure = $client->getVtMesure($device_id, $module_id, '1month',$types, $date_begin, $date_end);//, 1, null, null
      	if(isset($measure[0]['value'][0])){
          	$data=$measure[0]['value'][0];
          	//log::add('migoThermostat','debug', __FUNCTION__ .'	data : '.json_encode($data));
          	foreach(explode(',', $types) as $key=>$type){
              	$mesure_data[$type]=$data[$key];
            }
            $sb_on = $mesure_data["sum_boiler_on"];
          	$sb_off = $mesure_data["sum_boiler_off"];
			$taux = ($sb_on != 0) ? $sb_on/($sb_on + $sb_off) : 0;
			$mesure_data["tx_on"] = round($taux*100,1);
			$mesure_data["duree_on"] = round($taux * ($date_end-$date_begin)/60);
        	$multiplier = 1.056;
        }
      	$mesure_data["infos"] = ["function"=>__FUNCTION__, "date_begin"=>date("Y-m-d H:i", $date_begin), 
                            "date_end"=>date("Y-m-d H:i", $date_end), "units"=> $units , "data_type"=> $data_type, "types"=> $types
        ];
      	return $mesure_data;		
    }
/////////////////////////////////////*********************/////////////////////////////////////		
	public static function getNowMeasures($device_id, $module_id){
		$client = self::getClient('null');
		$date_begin = NULL;	
		$date_end = 'last';
		//sans espaces
      	$types = 'Temperature,Sp_Temperature,BoilerOn,BoilerOff,flow_setpoint,';
      	$types .= 'energy_gaz_heating,energy_gaz_hot_water,energy_elec_heating,energy_elec_hot_water';
      	$data_type = ["min_temp"=>"°C", "max_temp"=>"°C", "sum_boiler_on"=>"sec", "sum_boiler_off"=>"sec", "sum_energy_gaz_heating"=>"wh", "sum_energy_gaz_hot_water"=>"wh", "sum_energy_elec_heating"=>"wh", "sum_energy_elec_hot_water"=>"wh", "tx_on"=>"%", "duree_on"=>"min"];
		$units = '°C,°C,min,min,Wh,Wh,Wh,Wh';//,min,min,kWh,kWh,kWh,kWh
		$measure = $client->getVtMesure($device_id, $module_id, 'max',$types, $date_begin, $date_end, 1, null, null);
      	if(isset($measure[0]['value'][0])){
          	$data=$measure[0]['value'][0];
          	//log::add('migoThermostat','debug', __FUNCTION__ .'	data : '.json_encode($data));
          	foreach(explode(',', $types) as $key=>$type){
              	$mesure_data[$type]=$data[$key];
            }
            $sb_on = $mesure_data["BoilerOn"];
          	$sb_off = $mesure_data["BoilerOff"];
			$taux = ($sb_on != 0) ? $sb_on/($sb_on + $sb_off) : 0;
			$mesure_data["tx_on"] = round($taux*100, 1);
			//$mesure_data["duree_on"] = round($taux * ($date_end-$date_begin)/60);
        	//$multiplier = 1.056;
        }
      	$mesure_data["infos"] = ["function"=>__FUNCTION__, "date_begin"=> $date_begin, 
                            "date_end"=>$date_end, "units"=> $units , "data_type"=> $data_type, "types"=> $types
        ];
		return $mesure_data;		
    }  	
/////////////////////////////////////*********************/////////////////////////////////////		
	/////////////////////////////////////*********************/////////////////////////////////////		
	public static function getDataAll($device_id, $module_id) {
		$multiId = $device_id . '|' . $module_id;
		if (is_object(eqLogic::byLogicalId($multiId,'migoThermostat'))) {
			$eqLogic = eqLogic::byLogicalId($multiId,'migoThermostat');
		}
      	log::add('migoThermostat','debug', __FUNCTION__ .' starting... for: '.$eqLogic->getName());
		
		$client = self::getClient('int');
		$data_module = array();
		if ($module_id == 0) {
			$module_id = NULL;
		}
      	try{
			$yearbegin = strtotime('first day of January this year');
			$yearbegin2 = strtotime(date('Y-01-01 00:00'));
			$yearbegin3 = strtotime('first day of January last year ');
			$thismonth = strtotime('first day of this month midnight');//midnight
			$thismonth2 = strtotime(date('Y-m-01'));

			$now = strtotime(date('Y-m-d H:i'));//maintenant date et heure
			$todaymidnight=strtotime('today midnight');
			
          	$yesterday = strtotime('yesterday midnight');//Hier minuit
			$date_begin = $todaymidnight;	
			$date_end = $now;

			$measure['today'] = self::getDayMeasures($device_id, $module_id, null);
			$measure['yesterday'] = self::getDayMeasures($device_id, $module_id, $yesterday);
			$measure['thismonth'] = self::getMonthMeasures($device_id, $module_id, null);
			$measure['now'] = self::getNowMeasures($device_id, $module_id);
			$flowsetpoint = isset($measure['now']) ? $measure['now']['flow_setpoint'] : 0;
				
			$ConsoGaz_Jour = isset($measure['today']) ? ($measure['today']['sum_energy_gaz_heating'] + $measure['today']['sum_energy_gaz_hot_water'])/1000 : 0;
			$Consoelec_Jour = isset($measure['today']) ? ($measure['today']['sum_energy_elec_heating'] + $measure['today']['sum_energy_elec_hot_water'])/1000 : 0;
              
			$ConsoGaz_Hier = isset($measure['yesterday']) ? ($measure['yesterday']['sum_energy_gaz_heating'] + $measure['yesterday']['sum_energy_gaz_hot_water'])/1000 : 0;
			$Consoelec_Hier = isset($measure['yesterday']) ?  ($measure['yesterday']['sum_energy_elec_heating'] + $measure['yesterday']['sum_energy_elec_hot_water'])/1000 : 0;
			
            $ConsoGaz_Mois = isset($measure['thismonth']) ? ($measure['thismonth']['sum_energy_gaz_heating'] + $measure['thismonth']['sum_energy_gaz_hot_water'])/1000 : 0;
			$Consoelec_Mois = isset($measure['thismonth']) ? ($measure['thismonth']['sum_energy_elec_heating'] + $measure['thismonth']['sum_energy_elec_hot_water'])/1000 : 0;
			
			$duree_on_today = date('Hi', mktime(0, $measure['today']['duree_on']));
           	$duree_on_yesterday = date('Hi', mktime(0, $measure['yesterday']['duree_on']));
              
          	$data_module = $measure; 
			$subtitle  ="all";
            
		}//try
		catch (Exception $ex) {
          	$error_msg = " Exception:  " . $ex->getMessage() . "\n";
			log::add('migoThermostat', 'debug', $error_msg);
				
		}
		
		$data_module['type_graph'] = $subtitle;
		$data_module['name_module'] = $eqLogic->getName();
		
		
		
		log::add('migoThermostat','debug',  __FUNCTION__ .' data_module: '.json_encode($data_module));
		
		
		return($data_module);	
	}
  
/////////////////////////////////////*********************/////////////////////////////////////		
	public static function getDataGraph($device_id, $module_id, $scale=NULL, $type=NULL, $date_begin=NULL, $date_end=NULL, $limit=NULL, $subtitle=NULL, $real_time=NULL, $unit=NULL) {
		$multiId = $device_id . '|' . $module_id;
		if (is_object(eqLogic::byLogicalId($multiId,'migoThermostat'))) {
			$eqLogic = eqLogic::byLogicalId($multiId,'migoThermostat');
		}
      	log::add('migoThermostat','debug', __FUNCTION__ .' starting... for: '.$eqLogic->getName());
		$client = self::getClient('int');
		$data_module = array();
		if ($module_id == 0) {
			$module_id = NULL;
		}
      	try{
            if ($scale != NULL && $type != NULL) {
                /*log::add('migoThermostat','debug', __FUNCTION__.' multiId: '.$device_id . '|' . $module_id
              	.' scale: '.$scale.' type: '.$type.' date_begin: '.$date_begin .' date_end: '.$date_end.' limit: '.$limit);
				*/
                $measure = $client->getVtMesure($device_id, $module_id, $scale, $type, $date_begin, $date_end, $limit, FALSE, FALSE);
                log::add('migoThermostat','debug',  __FUNCTION__ .' mesure  : '. json_encode($measure));
                $data_module["infos"] = $measure;
                $data_module['dataType'] = $type;
                $data_module['unit'] = $unit;
            }
        }//try
		catch (Exception $ex) {
          	$error_msg = " Exception:  " . $ex->getMessage();
			log::add('migoThermostat', 'debug', $error_msg);
				
		}
		$data_module['type_graph'] = $subtitle;
		$data_module['name_module'] = $eqLogic->getName();
		log::add('migoThermostat','debug',  __FUNCTION__ .' data_module: '.json_encode($data_module));
		return($data_module);	
	}
	
/////////////////////////////////////*********************///////////////////////////////////// 
	//public static function syncDataGraph() {//cron cronHourly // cronDaily
		
} //Fin migoThermostatGraph	
?>