<?php
//error_reporting(E_ALL);
/* * ***************************Includes********************************* */

require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';
     
/* * ***************************  class migoThermostat_W  ********************************* */
const VT_BASE_URI = "https://api.netatmo.net/";
const VT_API_URI = VT_BASE_URI.'/api';
const VT_OAUTH_URI = VT_BASE_URI.'/oauth2/token';
const VT_USERAGENT = 'client_android';
const VT_SCOPES = 'read_thermostat write_thermostat read_station';

class migoThermostat_W {
  
  	protected $conf = array();
	public function __construct($Netatmo_user, $Netatmo_pass, $Netatmo_app_id, $Netatmo_app_secret){
        $this->_Netatmo_user = $Netatmo_user;
        $this->_Netatmo_pass = $Netatmo_pass;
        $this->_Netatmo_app_id = $Netatmo_app_id;
        $this->_Netatmo_app_secret = $Netatmo_app_secret;
    }
/* *  _nawLogin  ************************************************************ */
	private static function _nawToken($_retry = null){
      	$th_type = config::byKey('th_type', 'migoThermostat');
        if($th_type =="sdbg"){
          	$auth_uri = "https://auth.migo-thermostat.com";
        }elseif($th_type =="vaillant"){
        	$auth_uri = "https://auth.vg-thermostat.com";
        }else{
          	$auth_uri = null;
        }
      	if($auth_uri == null){
			log::add('migoThermostat', 'warning', '	'.__FUNCTION__ .' unable to set auth_uri ');
			return null;
		}
      	cache::set('migoThermostat_web',[]);
      	$cookiefile = jeedom::getTmpFolder('migoThermostat').'/cookie_migoThermostat';
		file_put_contents($cookiefile, 'null' . "\n");
        $headers = [];
      
      	$csrf_url = $auth_uri.'/fr-fr/access/login';
      	$csrf_rqst = self::wRequest($csrf_url, 'GET', null, true, $headers);
		preg_match('/.*<meta name="csrf-token" content="([a-zA-Z0-9]+)" \/>.*/m', $csrf_rqst['body'], $csrf);
		$csrf_token = isset($csrf[1]) ? $csrf[1] : false; 
			
		if(!$csrf_token){
			$csrf_content = file_get_contents($cookiefile);
			log::add('migoThermostat', 'warning', '	'.__FUNCTION__ .' No csrf: '.$csrf_content.' body: '.$csrf_rqst['body']);
			return null;
		}
		log::add('migoThermostat','debug', '	'.__FUNCTION__.' csrf ok, getting token...');

		$next_url = '';//'https://my.migothermostat.com/app/energy';
              	   
		$auth_url = $auth_uri.'/access/postlogin';
      	$formData = array(
                    'email'			=> config::byKey('username', 'migoThermostat'),
                    'password'		=> config::byKey('password', 'migoThermostat'),
                    'stay_logged'	=> 'on',
                    '_token'	=> $csrf_token
		);
      	$headers = [
          	"Cache-Control"=> "max-age=0",
            "Connection"=> "keep-alive.",
            "Upgrade-Insecure-Requests"=> 1,
        ];
		try{
          $auth_rqst = self::wRequest($auth_url, 'POST', $formData, true, $headers);
        }
      	catch (Exception $ex) { 
          	$er_msg = $ex->getMessage();
          	log::add('migoThermostat', 'warning', __FUNCTION__ ." ".$er_msg);
        }
      	if($th_type =="sdbg"){
          	$token_name = "migothermostatcomaccess_token";
        }elseif($th_type =="vaillant"){
        	$token_name = "vgthermostatcomaccess_token";
        }else{
          	$token_name = "netatmocomaccess_token";
        }
      
      	if(isset($auth_rqst['headers'])){
          	$ar_token = self::getheadersVal($auth_rqst['headers'], 'Set-Cookie', $token_name);
        }else{
          	return false;
        }
      	
      	
      	if (isset($ar_token[$token_name]) && strlen($ar_token[$token_name]) == 59 && $ar_token[$token_name] != "deleted" ){
      		$ar_token['access_token'] = urldecode($ar_token[$token_name]);
          	$ar_token['expire'] = strtotime($ar_token['expires']);
			$ar_token['token_date'] = time();
          	$ar_token['expires_at'] = (time() + 10800 - 200);
          	
          	
        	unset($ar_token['expires']);
          	unset($ar_token['path']);
          	unset($ar_token['']);
            //log::add('migoThermostat', 'debug', __FUNCTION__ .' cookie_content: '.$cookie_content);
			if(1 == 2){
                $cookie_content = file_get_contents($cookiefile);
            	preg_match("/migothermostatcomci_csrf_cookie_na\s*(.*)/", $cookie_content, $match_csrf);
            	$csrf = trim(array_pop($match_csrf));
          		$ar_token['csrf'] = $csrf;
              	
              	$ar_laravel = self::getheadersVal($auth_rqst['headers'], 'Set-Cookie', 'authmigothermostatcomlaravel_session');
                    $ar_token['authmigothermostatcomlaravel_session'] = $ar_laravel['authmigothermostatcomlaravel_session'];
                    //log::add('migoThermostat', 'debug', __FUNCTION__ .' $ar_laravel: '.json_encode($ar_laravel));
                $ar_refresh = self::getheadersVal($auth_rqst['headers'], 'Set-Cookie', 'authmigothermostatcomrefresh_token');
                    $ar_token['authmigothermostatcomrefresh_token'] = $ar_refresh['authmigothermostatcomrefresh_token'];
                    log::add('migoThermostat', 'debug', __FUNCTION__ .' ar_refresh: '.$ar_refresh['authmigothermostatcomrefresh_token'].json_encode($ar_refresh));
                $ar_xsrf = self::getheadersVal($auth_rqst['headers'], 'Set-Cookie', 'XSRF-TOKEN');
                    $ar_token['XSRF-TOKEN'] = $ar_xsrf['XSRF-TOKEN'];
                  	//log::add('migoThermostat', 'debug', __FUNCTION__ .' $ar_xsrf: '.json_encode($ar_xsrf));
        	}
          	cache::set('migoThermostat_web', $ar_token);
          	//log::add('migoThermostat', 'debug', __FUNCTION__ .' w_token: '.$ar_token['access_token']);
			return $ar_token;
          	
        }
      	else{
          	return false;
        }
    }
/* *  getwlogin  ************************************************************ */
	public static function getlogin($forced = false){
      	$login_ar = cache::bykey('migoThermostat_web')->getValue();
		$msg = false;
		if($forced==true){
			$msg = " Forced reniew token...";
		}elseif(!isset($login_ar['access_token']) || !isset($login_ar['token_date']) ){
			$msg = " No token strored";
		}elseif( ($diff=(time() - $login_ar['token_date'] )) > 7400 ){
			$msg = " token too old ".$diff.'-- token_date: '.date('d-m-Y H:i',$login_ar['token_date']);
		}
      	/*elseif(($diff=($login_ar['expire'] - time())) < 3500 ){
			$msg = " token expire ".$diff.'-- expire: '.date('d-m-Y H:i',$login_ar['expire']);
		}*/
            
		if($msg){
          	log::add('migoThermostat', 'debug', __FUNCTION__ .$msg);
			$i = 1;
            while ($i <= 3) {
              	//log::add('migoThermostat', 'debug', __FUNCTION__ .' retry : '.$i);
                $login = self::_nawToken($i);
              	if (isset($login['access_token']) && strlen($login['access_token']) >= 57){
                    break;
                }
                sleep(1);
                $i++;
            }
            if ($i >= 3) {
              	log::add('migoThermostat', 'warning', '	'.__FUNCTION__ .' unable to get w_token: '.json_encode($login));
              	$login = self::getApiToken();
              	if (isset($login['access_token']) && strlen($login['access_token']) >= 57){
                  	//log::add('migoThermostat', 'debug', __FUNCTION__ .' getApiToken: '.json_encode($login));
                   	return $login;
                }
              	$er_msg =  __FUNCTION__ .":: Impossible d'obtenir un token après ".($i-1)." essais";
                //log::add('migoThermostat', 'debug', $er_msg);
              	throw new Exception($er_msg, 0);
                return false;
            }
          	log::add('migoThermostat', 'debug', __FUNCTION__ .' new w_token: '.$login['access_token']);
            return $login;
        }
  		else{
          	//log::add('migoThermostat', 'debug', __FUNCTION__ .' token_c: '.$login_ar['access_token']);
          	return $login_ar;
        }
	}
  	/* *  formatArray  ************************************************************ */
	private static function formatArray($array){
      	$result=[];
        foreach ($array as $key => $value){
			if(is_array($value)){
              	$result[$key] = self::formatArray($value);
            }
          	//elseif (!is_string($value) && !is_array($value)){
			elseif (is_bool($value) || $value == null){
				$result[$key] = json_encode($value);
			}else{
              	$result[$key] = $value;
            }
		}
      	return $result;
      
    }
   
/* *  wRequest  ************************************************************ */
	public static function wRequest($_path, $method = 'GET', $params=null, $cookie = true, $headers = array(), $retry = false){
        $ch = curl_init();
        $method = strtoupper($method);
      	$opts =  [
            CURLOPT_CONNECTTIMEOUT => 10,
            CURLOPT_RETURNTRANSFER => TRUE,
            CURLOPT_HEADER         => TRUE,
            CURLOPT_TIMEOUT        => 80,
            CURLOPT_USERAGENT      => "migoThermostat(JeedomW) Android(9.1/HUAWEI/HUAWEI CUN-L21)",
        	CURLOPT_SSL_VERIFYPEER => TRUE,
          	CURLINFO_HEADER_OUT	   => TRUE,
          	CURLOPT_FOLLOWLOCATION => TRUE,
            CURLOPT_HTTPHEADER     => array("Accept: application/json"),
        ];
      	if($cookie){
          	$cookiefile = jeedom::getTmpFolder('migoThermostat').'/cookie_migoThermostat';
          	$opts[CURLOPT_COOKIEJAR] =  $cookiefile;
          	$opts[CURLOPT_COOKIEFILE] = $cookiefile ;
        }
      	$query=null;
           
		if(is_array($params) && !empty($params)  ){
			$params = self::formatArray($params);
          	if(isset($params['access_token'])){
                $opts[CURLOPT_HTTPHEADER][] = 'Authorization: Bearer ' . $headers['access_token'];
                unset($params['access_token']);
            }
            $query = http_build_query($params, NULL, '&');
          	
        }
      	
      	switch ($method){
                case 'GET':
                	$opts[CURLOPT_HTTPGET] = TRUE;
                   	$path = $query ? $_path."?".$query : $_path;
                    $lenght = strlen($query);
              
            		break;
                case 'POST':
            		//$opts[CURLOPT_CUSTOMREQUEST] = "POST";
            		$opts[CURLOPT_POST] = TRUE;
            		
            		$path = $_path;
            		if($params){
                      	if(is_array($params)){
                         	$opts[CURLOPT_POSTFIELDS] = $query;
                          	$lenght = strlen($query);
                      	}
                      	elseif(json_decode($params)){
                            $opts[CURLOPT_POSTFIELDS] = $params;
                            $query = http_build_query(json_decode($params)) ;
                            $lenght = strlen($query);
                        }
                        else {
                            $query = $params;
                            $opts[CURLOPT_POSTFIELDS] = $params;
                          	$lenght = strlen($query);
                        }
                    }
            
            	break;
            	default:
            	break;
            }
        if (!empty($headers)){
          	if(isset($headers['access_token'])){
                $opts[CURLOPT_HTTPHEADER][] = 'Authorization: Bearer ' . $headers['access_token'];
                unset($headers['access_token']);
            }
          	if(isset($headers['Content-Type'])){
                $opts[CURLOPT_HTTPHEADER][] = 'Content-Type: ' . $headers['Content-Type'];
            }
		}else{
              	//$opts[CURLOPT_HTTPHEADER][] = 'Content-Type: ' .  "application/json; charset=utf-8";
        }
      	$method_path = parse_url($_path, PHP_URL_PATH);
		$end_point = substr($method_path, strrpos($method_path, '/') + 1);
      	//log::add('migoThermostat', 'debug', __FUNCTION__ ." api_path : ".$end_point);
        
        $opts[CURLOPT_URL] = $path;
      	//log::add('migoThermostat', 'debug', __FUNCTION__ ." $method path: ".$path);
      	if (isset($opts[CURLOPT_HTTPHEADER])){
            $existing_headers = $opts[CURLOPT_HTTPHEADER];
            $opts[CURLOPT_HTTPHEADER] = $existing_headers;
        }
        else{
            $opts[CURLOPT_HTTPHEADER] = array('Expect:');
        }
      	//log::add('migoThermostat', 'debug', __FUNCTION__ ." query : ".$lenght .'---'.$query);
      	//log::add('migoThermostat', 'debug', __FUNCTION__ .' existing_headers: '.json_encode($existing_headers));
      	$lenght ? $opts[CURLOPT_HTTPHEADER]['Content-length'] = $lenght : "" ;
     	//log::add('migoThermostat', 'debug', __FUNCTION__ .' HTTPHEADER: '.json_encode($opts[CURLOPT_HTTPHEADER]));
      	curl_setopt_array($ch, $opts);
        $result = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		
        $errno = curl_errno($ch);
        // CURLE_SSL_CACERT || CURLE_SSL_CACERT_BADFILE
        if ($errno == 60 || $errno == 77){
            log::add('migoThermostat', 'debug', __FUNCTION__ ." WARNING ! SSL_VERIFICATION has been disabled...");
          	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            $result = curl_exec($ch);
        }
		if ($result === FALSE){
          	$er_code = +curl_errno($ch);
          	$er_msg = ' curl Error ('.curl_errno($ch).") : ".curl_error($ch).' at '.$end_point;
          	log::add('migoThermostat', 'warning', __FUNCTION__ .' ' . $er_msg );
          	if ($er_code == 6){//Could not resolve host: xxx
              	$er_msg .= " >>> Server down ?";
            }elseif($er_code == 7){
              	$er_msg = " curl error(".$er_code.") : Serveur injoignable ! vérifier votre connexion internet ou Serveur down at ".$end_point;
            }elseif ($er_code == 28 && $retry == false){
              	$er_msg = " curl error(".$er_code.") : Serveur 'Timeout'! Pas de réponse après ".$opts[CURLOPT_TIMEOUT]." secondes at ".$end_point;
              	log::add('migoThermostat', 'error', __FUNCTION__ .' er_code: ' . $er_code. " ... retry" );
              	sleep(3);
              	return self::wRequest($_path, $method, $params, $cookie, $headers, true);
            }
            throw new Exception($er_msg, $er_code);
        }	
        //log::add('migoThermostat', 'debug', __FUNCTION__ .' http_code: '.$http_code.'--'.$result);
        
        curl_close($ch);
	
      	// Split the HTTP response into header and body.
        list($rsp_headers, $body) = explode("\r\n\r\n", $result);
        $rawHeaders = explode("\r\n", $rsp_headers);
      	
      	preg_match('/^HTTP\/1.1 ([0-9]{3,3}) (.*)$/', $rawHeaders[0], $matches);
      	$match_code = $matches[1];
      	$http_status = $matches[2];
      	      	
      	if( $end_point == "postlogin" && ($match_code != 302 || $http_code != 200)){    
      		log::add('migoThermostat', 'info', __FUNCTION__ .' match_code: '.$match_code.'-- http_code '.$http_code." ".json_encode($rawHeaders));
        }
      	if(substr($http_code, 0, 1) === '2'){
            $decode = json_decode($body, TRUE);
            if(!$decode){
                $rsp_body = $body;
              	//log::add('migoThermostat', 'debug', __FUNCTION__ .' !decode $body: '.$rsp_body);
            } else {
              	$rsp_body= (isset($decode['body']) ? $decode['body'] : $decode);
              	//log::add('migoThermostat', 'error', __FUNCTION__ .' decode body: '.json_encode($decode, true));
            }
          	$return['code']= $http_code;
          	$return['body'] = $rsp_body; 
          	$return['status']=strtolower($http_status);
          	$return['headers'] = $rawHeaders;
        }
        else{
            $decode = json_decode($body, TRUE);
          	if(!$decode){
              	$er_code = $http_code;
              	$ermsg = "Rqst_Error ($er_code) ".$end_point ." : $http_status";
              	//log::add('migoThermostat', 'warning', __FUNCTION__ .' body: '.$body);
        		//log::add('migoThermostat', 'warning', __FUNCTION__ .' rawHeaders: '.json_encode($rawHeaders) );
              	if( $end_point != "postlogin" && $match_code != 302 ){
              		log::add('migoThermostat', 'warning', __FUNCTION__ .' !decode3: '.$ermsg);
              		throw new Exception($ermsg, $er_code);
                }
            }else{
               	$status = array_keys($decode)[0];
               	$msg = array_values($decode)[0];
              	//log::add('migoThermostat', 'debug', __FUNCTION__ .' http_code '.$http_code." ".json_encode($result, true));
				
              	if($status == "error"){
                  	//log::add('migoThermostat', 'debug', __FUNCTION__ .' msg: '.$msg['message']);
               		//$er_msg = ( isset($msg['message']) )?$msg['message'] : isset($decode['error_description']) ? $decode['error_description']: "";
                	if(isset($msg['message'])){
                      $er_msg = $msg['message'];
                    }elseif(isset($decode['error_description'])){
                      $er_msg = $decode['error_description'];
                    }elseif(is_string($decode['error'])){
                      $er_msg = $decode['error'];
                    }else{
                       $er_msg = json_encode($msg);
                    }
                  	$er_code = (isset($msg['code'])) ? $msg['code']: $http_code;
                  	$ermsg = " API_Erreur (code $er_code) at ".$end_point. " : ".$er_msg ;
                  	log::add('migoThermostat', 'warning', __FUNCTION__ .' throwing...'.$ermsg);
                  	throw new Exception($ermsg, $er_code);
                }else{
                  	$er_code = $http_code;
                  	$ermsg = " request_Erreur (code $er_code) at ".$end_point. " : ".$http_status ;
                  	log::add('migoThermostat', 'warning', __FUNCTION__ .' ...'.$ermsg);
                }
           	}
          	$return['code']= ($er_code !== null) ? $er_code : $http_code;
          	$return['body'] = $ermsg;
          	$return['status'] = strtolower($status);//strtolower($http_status);
          	$return['headers'] = $rawHeaders;
        }
      	//log::add('migoThermostat', 'debug', __FUNCTION__ .' return '.$end_point ." ".json_encode($return));
		return $return;
    } 
  	
/* *  _setTrueTemperature  ************************************************************ */
	public static function _setTrueTemperature($home_id, $room_id, $current_temperature, $corrected_temperature){
      	$base_url = VT_BASE_URI.'/api/truetemperature';
        $params = [
                      'home_id'=>strval($home_id),
                      'room_id'=>strval($room_id),
                      'current_temperature'=>floatval($current_temperature),
                      'corrected_temperature'=>floatval($corrected_temperature),
        ];
    	//log::add('migoThermostat', 'debug', __FUNCTION__ .' params: '.json_encode($params));
    	$response = self::wapi($base_url, 'POST', $params, false);
		return $response;
	}

/* *  getApi  ************************************************************ */
	public static function getApi($url,$params=null){
        $response = file_get_contents($url, false);
        $jsonDatas = json_decode($response, true);
        $body=null;
        if( isset($jsonDatas['body']) ){
          $body = json_encode($jsonDatas['body']);
        }elseif( isset($jsonDatas['status']) ){
          $body = json_encode($jsonDatas['status']);
        }
      	log::add('migoThermostat', 'debug', __FUNCTION__ .' body '.$body);
        return $body;
	}

/* *  getheadersVal  ************************************************************ */
	private static function getheadersVal($headers, $keyhead, $val=''){
		$keyleng=strlen($keyhead);
      	$valleng=strlen($val);
      	$result = [];
       	foreach ($headers as $entry){
			if (substr($entry, 0, $keyleng) == $keyhead 
                && substr($entry, $keyleng+2, $valleng) == $val){
				$found=substr($entry, $keyleng+2, $valleng);
              	$return=trim(substr($entry, $keyleng+2));
              	if($val=='' && $return) return array($keyhead => $return);
              	$exp=explode(';', $return);
        		if(is_array($exp) && !empty($exp)){
                  	foreach ($exp as $expvalue){
                      //list($key, $fval) = explode('=', trim($expvalue), 2);
                      list($key, $fval) = array_pad(explode('=', trim($expvalue), 2), -2, null);
                      //ll
                      $result[trim($key, "\x1B\x00..\x1F")]=trim($fval, "\x00..\x1F");
                    }
                }
            break;
            }
        }
    	return $result;
    }

/* *  wapi  ************************************************************ */
  	public static function wapi($path, $method = 'GET', $params = array(), $retry=false){
        if (is_array($method) && empty($params)){
            $params = $method;
            $method = 'GET';
        }
      	$login = self::getlogin();
      	$headers = array();
      	if(!isset($login["access_token"])){
        	log::add('migoThermostat', 'debug', __FUNCTION__ .' No web_token set '.json_encode($login));
          	return array("body"=>"No web_token set", "status"=>"error");
        }
      	else{
          	$headers['access_token'] = urldecode($login["access_token"]);//"";//
          	$headers['Content-Type'] = 'application/json';//application/json; charset=utf-8
          	//log::add('migoThermostat', 'debug', __FUNCTION__ .' access_token: '.urldecode($login["access_token"]) .json_encode($login));
        }
      	
      	if (substr($path, 0, 4) == "http") $url = $path;
      	else $url = VT_API_URI . '/' . ltrim($path, '/');
      
		$params = ($method == "POST") ? json_encode($params, true) : $params;
		try{
			$rqst = migoThermostat_W::wRequest($url, $method, $params, true, $headers);
			if(isset($rqst["body"]) && $rqst["body"] == 'Invalid access token' && !$retry){
				$login = self::getlogin(true);
				return self::wapi($url, $method, $params, true);
          	
        	}
      	
			if(isset($rqst["body"]) && $rqst["status"] == "ok" ){
                return $rqst["body"];
            }else{
                return $rqst;
            }
        }
      	catch (Exception $ex) { 
          	$msg=$ex->getMessage();
			if($retry == false && stripos($msg, 'access token') ){//$ex->getCode() == 2 || 1 || 3 
				log::add('migoThermostat', 'warning', __FUNCTION__ .'token error catched : '.$ex->getMessage()." ".$ex->getCode());
          		$login = self::getlogin(true);
				return self::wapi($url, $method, $params, true);
          	
        	}
          	$error_msg = __CLASS__.'::'.__FUNCTION__." Erreur " .$ex->getCode()." : ". $ex->getMessage();
          	throw new Exception($error_msg);
        }
    }
  
/* *  _getHomesdata  ************************************************************ */
	public static function _getHomestatus($home_id = NULL){
        //$params = array("detailed_config" => true);
        $params = [
          "data_amount"=>"app",
          "sync_measures"=>true,
          "detailed_config"=>true,
          "app_version"=>"3.5.4.0",
          "app_type"=>"app_thermostat"
        ];
      
      	if(!is_null($home_id)) $params['home_id'] = $home_id ;
		//if(!is_null($gateway_types)) $params['gateway_types'] = $gateway_types ;
      	return self::wapi(BASE_URI."/syncapi/v1/gethomestatus", 'POST', $params);
     
    }
  	/* *  _getHomesdata  ************************************************************ */
	public static function _getoutdoortemperature($device_id){
        //$params = array("detailed_config" => true);
        $params = [
          "device_id"=>$device_id,
          "app_version"=>"3.5.4.0",
        ];
      	return self::wapi('getoutdoortemperature', 'POST', $params);
     
    }
/* *  revokeToken  ************************************************************ */
	public static function testWhook($url, $data = array()){
        $ch = curl_init($url);

        $data = array(
            'username' => 'testuser',
            'password' => '123456'
        );
        $payload = json_encode(array("user" => $data));
		curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($ch);
		curl_close($ch);
    }
  /* *  _getHomesdata  ************************************************************ */
  	public static function revokeToken($token){
      	$headers=array();
      	$headers['access_token']='Authorization: Bearer ' 
          	.'client_id:'.config::byKey('username', 'migoThermostat') 
      		.',client_secret:'.vt::checkClient(config::byKey('th_type', 'migoThermostat'));
        	$auth_url= VT_BASE_URI.'/oauth2/revoke';
          	$params = array(
                    'client_id'			=> 'na_client_android_'.config::byKey('th_type', 'migoThermostat'),
                    'client_secret'		=> '',
                    'access_token'	=> $token,
                    '_token'	=> $token
            );
            $auth_rqst = self::wRequest($auth_url, 'POST', $params, true, $headers);
  
  			return $auth_rqst;
    }
  
	public static function getApiToken($refresh=null) {
      	$cookie = false;
      	$headers = ['Content-Type' => 'application/x-www-form-urlencoded',];
		$return = self::wRequest(VT_OAUTH_URI, 
                                 'POST', [
									'client_id' => 'na_client_android_'.config::byKey('th_type', 'migoThermostat'),
                                    'client_secret' => vt::checkClient(config::byKey('th_type', 'migoThermostat')),
                                    'username' => config::byKey('username', 'migoThermostat'),
                                    'password' => config::byKey('password', 'migoThermostat'),
                                    'grant_type' => $refresh ? 'refresh_token':'password',
									'scope' => VT_SCOPES,
                                    'user_prefix' => config::byKey('th_type', 'migoThermostat')], 
                                 $cookie, $headers
        );
      
  		if( isset($return['body']['access_token']) ){
          	$return['body']['token_date'] = time();
          	$return['body']['expire'] =  time() + 10800;//$return['body']['body']
          	$return['body']['expires_at'] = (time() + 10800 - 200);
          	cache::set('migoThermostat_web', $return['body']);
          	return $return['body'];
        }
    }

/* *  _Homesdata  ************************************************************ */
	public static function _Homesdata($home_id = NULL, $gateway_types = array('NAVaillant','NAPlug','OTH')){
        $params = [
          			"gateway_types"=>['NAPlug','OTH'],
       				"detailed_config"=>true,
       				"home_id"=>$home_id,
       				"gateway_parameters"=> ["NAPlug"=>["sync_measures"=>true]]
        ];
      	if(!is_null($home_id)) $params['home_id'] = $home_id ;
		//if(!is_null($gateway_types)) $params['gateway_types'] = $gateway_types ;
      	//log::add('migoThermostat', 'debug', '	'.__FUNCTION__ .' params : '.json_encode($params));
      	return self::wapi('homesdata', 'POST', $params);
     
    }
  	
/* *  _Homestatus  ************************************************************ */
	public static function _Homestatus($home_id = NULL){
        //$params = array("detailed_config" => true);
         
      	$params = [
          			"app_version"=>"1.26.2.0",
          			"device_types"=>['NAPlug','OTH'],
          			"app_type"=>"app_magellan",
       				"detailed_config"=>true,
       				"home_id"=>$home_id
        ];
      	if(!is_null($home_id)) $params['home_id'] = $home_id ;
		//if(!is_null($gateway_types)) $params['gateway_types'] = $gateway_types ;
      	return self::wapi(VT_BASE_URI.'/syncapi/v1/homestatus', 'GET', $params);
     
    } 
   	public static function getVtData($device_id = NULL) {
    
    	
		$params =['device_type'=>'NAVaillant',//['NAVaillant','NAPlug','OTH'],
                  'app_version'=>"1.1.0.2",
                  "detailed_config"=>true,
                  "app_type"=>"app_magellan",
       				
                  //'sync_device_id'=>"all"
                 ];//,'lower_access_level'=>"0"
		$params['device_id'] = ($device_id != NULL) ? $device_id :"all";
		$return = self::wapi('getthermostatsdata', 'GET', $params);
      	return $return;
	}
  
}

	


?>