<?php
error_reporting(0);

header('Content-type: application/json');
ob_start();
$out = ob_get_clean();
echo trim(substr($out, strpos($out, '{')));

require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';

$code = 200;
$text = 'OK';
$protocol = (isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0');
header($protocol . ' ' . $code . ' ' . $text);
$GLOBALS['http_response_code'] = $code;

if (!init('apikey') || init('apikey') != jeedom::getApiKey('migoThermostat')) {
	log::add('migoThermostat', 'error', ' incoming_push wrong apikey');
  	die();
}


$DateS = date("d-m-Y H:i:s");
$DateM = date("d-m-Y H:i");
$jsonData = file_get_contents("php://input");
log::add('migoThermostat', "warning", __FUNCTION__ .' push: '.var_export($jsonData, TRUE));

/*
if(hash_hmac("sha256", $jsonData, "cls") !== $_SERVER['HTTP_X_NETATMO_SECRET']){
    log::add('migoThermostat', 'error', 'Wrong signature webhooks data '.$_SERVER['HTTP_X_NETATMO_SECRET']);
  	die();
}
*/
try {
    if(!is_null($jsonData) && !empty($jsonData)){
        $push = json_decode($jsonData, TRUE);
        if(!$push){
          log::add('migoThermostat', 'error', "Bizard push : ".$jsonData);
          return;
        }
      	if(!isset($push['event_type']) && !isset($push['push_type'])){
          log::add('migoThermostat', 'error', "vt_whook Bizard event : ".$jsonData);
          return;
        }
      
      	$event_type = isset($push['event_type']) ? $push['event_type'] : false;
      	$push_type = isset($push['push_type']) ? $push['push_type'] : false;//home_event_changed
       	if($push_type == 'webhook_activation'){
          	$msg=$event_type.' '.json_encode($push, TRUE);
          	$needRefresh = false;
          	$typeEq=null;
          	foreach(eqLogic::byType('migoThermostat', true) as $eqLogic) {
          		list($eqroomid,$eqhomeid) = explode('|', $eqLogic->getLogicalId());
          		if ($eqroomid=='Home') {
          			//log::add('migoThermostat', 'error', 'vt_whook whook subscribd : '.$eqLogic->getName());
          			//$eqhomes[]=$eqLogic;
          			$whookcmd = $eqLogic->getCmd(null, 'wbhook_last');
          			if (is_object($whookcmd)){
                      	$whookcmd->setConfiguration('subscribe_date', $DateS);
          				$whookcmd->save();
                    }
          		}
          	} 
          	return;
		}
      	elseif($push_type == 'topology_changed'){
          	$change = isset($push['change']) ? $push['change'] : "";
          	$change_data = isset($push['home']) ? json_encode($push['home']) : "";
          	$msg = ' topology_changed : '.$change.' '.' => '. $change_data;
          	log::add('migoThermostat', 'error', '	whook : '. $msg);  
          	return;
		}
      	$mode  = isset($push['mode']) ? $push['mode'] : false; //= $push['mode'];
        $push_message = isset($push['message']) ? $push['message'] : false;
        $homeName = isset($push['home']['name']) ? $push['home']['name'] : false;
        $homeId =  isset($push['home']['id']) ? $push['home']['id'] : false;//$push['home']['id'];
        $roomName = isset($push['rooms'][0]['name']) ?  $push['rooms'][0]['name'] : false;
      //$push['rooms'][0]['name'];
      
		if( $push_message ){
          		$pushAr=[];
			//log::add('migoThermostat', 'debug', 'vt_whook Webhook notif: '.$push['message']);
		}
      
		
	
		$msg='';
		switch($event_type) {
			case 'therm_mode':
            	$eqLogicId= 'Home|'.$homeId;
				//$msg = $eqLogicId." ** Mode Changed  from ".$push['previous_mode'].' to '.$push['mode'];
            	$msg = $eqLogicId." ** Mode set to ".$push['mode'];
            	$needRefresh=true;
            	$typeEq='Home';
            	$pushAr["migoThermostat_id"] = $eqLogicId;
            	$pushAr["mode"] = $push['mode'];
            	$pushAr["sp_endTime"] = isset($room['therm_setpoint_end_time']) ? $room['therm_setpoint_end_time'] : "";
            	$pushAr["sp_endTime"] = isset($push['home']['therm_mode_endtime']) ? $push['home']['therm_mode_endtime'] : "";
            
				//log::add('migoThermostat', 'error', 'vt_whook '.$msg);
        		break;
			case 'schedule':						
				$eqLogicId= 'Home|'.$push['home_id'];
				$msg = $eqLogicId." ** Planninig Changed to ".$push['schedule_id'];
				$needRefresh=true;
            	$typeEq='Home';
            	$pushAr["migoThermostat_id"] = $eqLogicId;
            	$pushAr["schedule_id"] = $push['schedule_id'];
				//log::add('migoThermostat', 'error', 'vt_whook '.$msg);
        		break;
			case 'set_point':						
				
            	$roomlist='';
				foreach ($push['home']['rooms'] as $room) {
					$eqLogicId = $room['id'].'|'.$homeId;
                  	//$roomlist .= $eqLogicId.'|;';
                  	$sp_endTime=isset($room['therm_setpoint_end_time'])? ' ->'.$room['therm_setpoint_end_time']:'';
                  	$msg = $eqLogicId. " ** Mode to manuel : ".$push['temperature'];
				}
            	$pushAr["migoThermostat_id"] = $eqLogicId;
            	$pushAr["mode"] = $push['mode'];
            	$pushAr["temperature"] = $push['temperature'];
            	$pushAr["sp_endTime"] = isset($room['therm_setpoint_end_time']) ? $room['therm_setpoint_end_time'] : 0;
				
				$needRefresh=true;
				$typeEq='room';
            	break;
			case 'cancel_set_point':
				$roomlist='';
				foreach ($push['home']['rooms'] as $room) {
					$eqLogicId = $room['id'].'|'.$homeId;
                  	$roomlist .= $eqLogicId.'|;';
                  	$msg= $eqLogicId." ** Manuel Mode canceled";
                }
				$needRefresh = true;
				$typeEq='room';
            	$roomId = $room['id'];
            	$eqLogicId= $room['id'].'|'.$homeId;
            	$pushAr["migoThermostat_id"] = $eqLogicId;
            	$pushAr["mode"] = $push['mode'];
            	$pushAr["cancel_set_point"] = true;
            	//$pushAr["sp_endTime"] = $sp_endTime;
				//log::add('migoThermostat', 'error', $msg);
        		break; 
			default:
            	$needRefresh = false;
                $msg=$event_type.' '.json_encode($push, TRUE);
            	return log::add('migoThermostat', 'warning', '	vt_whook unformated Notif : '. $msg.' => '.json_encode($pushAr)); 
		}  
        log::add('migoThermostat', 'warning', '	vt_whook Notif : '. $msg.' => '.json_encode($pushAr));  
		
      	$eqhome_Id= 'Home|'.$homeId;
		/*$eqhome = migoThermostat::byLogicalId($eqhome_Id, 'migoThermostat');
		if ($needRefresh == true && is_object($eqhome)) {
          	//com_shell::execute(system::getCmdSudo() .'chmod 777 -R ' . $path. ' > /dev/null 2>&1;');
			//file_put_contents($path.'/nalogs.txt', $DateS.": \n".json_encode($push, JSON_PRETTY_PRINT)."\n", FILE_APPEND);
			$whookcmd = $eqhome->getCmd(null, 'wbhook_last');
			if (is_object($whookcmd)){
				$eqhome->checkAndUpdateCmd($whookcmd, $msg);
               	$last_whookTime[$DateM][]=$room['name'];
				$whookcmd->setConfiguration('origin', 'ext');
				$whookcmd->setConfiguration('whook_time', $last_whookTime);
				$whookcmd->setValue($last_whookTime);
				$whookcmd->save();
			}
        }
      */
	}

}catch (Exception $ex) {	
	log::add('migoThermostat', 'debug', 'vt_whook Erreur whook :'.$ex->getMessage());

}  


  
?>